# Espresso

[![PyPI version](https://img.shields.io/pypi/v/geo-espresso?logo=pypi&style=flat-square&color=bde0fe&labelColor=f8f9fa)](https://pypi.org/project/geo-espresso/)
[![build](https://img.shields.io/github/actions/workflow/status/inlab-geo/espresso/build_wheels.yml?branch=main&logo=githubactions&style=flat-square&color=ccd5ae&labelColor=f8f9fa)](https://github.com/inlab-geo/espresso/actions/workflows/build_wheels.yml)
[![Documentation Status](https://img.shields.io/readthedocs/geo-espresso?logo=readthedocs&style=flat-square&color=fed9b7&labelColor=f8f9fa&logoColor=eaac8b)](https://geo-espresso.readthedocs.io/en/latest/?badge=latest)
[![Slack](https://img.shields.io/badge/Slack-InLab_community-4A154B?logo=slack&style=flat-square&color=cdb4db&labelColor=f8f9fa&logoColor=9c89b8)](https://join.slack.com/t/inlab-community/shared_invite/zt-1ejny069z-v5ZyvP2tDjBR42OAu~TkHg)

> Related repositories by [InLab](https://inlab.edu.au/community/)
> - [CoFI](https://github.com/inlab-geo/cofi)
> - [CoFI Examples](https://github.com/inlab-geo/cofi-examples)

## Introduction

**E**arth **S**cience **PR**oblems for the **E**valuation of **S**trategies, 
**S**olvers and **O**ptimizers (Espresso) is a collection of datasets, and 
associated simulation codes, spanning a wide range of geoscience problems. 
Together they form a suite of real-world test problems that can be used to 
support the development, evaluation and benchmarking of a wide range of tools
and algorithms for inference, inversion and optimisation. All problems are 
designed to share a common interface, so that changing from one test problem
to another requires changing one line of code. 

The Espresso project is a community effort - if you think it sounds useful,
please consider contributing an example or two from your own research. The project
is currently being coordinated by InLab, with support from the CoFI development
team.

For more information, please visit [our documentation](geo-espresso.readthedocs.io).


## Installation

```console
$ pip install geo-espresso
```

Check Espresso documentation - 
[installation page](https://geo-espresso.readthedocs.io/en/latest/user_guide/installation.html) 
for details on dependencies and setting up with virtual environments.

## Basic usage

Once installed, each test problem can be imported using the following command:

```python
from espresso import <testproblem>
```

Replace ``<testproblem>`` with an actual problem class in Espresso, such as
`SimpleRegression` and `FmWavefrontTracker`. See 
[here](https://geo-espresso.readthedocs.io/en/latest/user_guide/contrib/index.html) 
for a full list of problems Espresso currently includes.

Once a problem is imported, its main functions can be called using the same 
structure for each problem. For instance:

```python
from espresso import FmWavefrontTracker

problem = FmWavefrontTracker(example_number=1)
model = problem.good_model
data = problem.data
pred = problem.forward(model)
fig_model = problem.plot_model(model)
```

You can access related metadata programatically:

```python
print(FmWavefrontTracker.metadata["problem_title"])
print(FmWavefrontTracker.metadata["problem_short_description"])
print(FmWavefrontTracker.metadata["author_names"])
```

Other problem-specific parameters can be accessed through the problem instance. For instance:

```python
print(problem.extent)
print(problem.model_shape)
```

Which additional values are set is highly problem-specific and we suggest to 
consult the 
[Espresso Documentation on the problems](https://geo-espresso.readthedocs.io/en/latest/user_guide/contrib/index.html).


## Contributing

Interested in contributing? Please check out our [contributor's guide](https://geo-espresso.readthedocs.io/en/latest/contributor_guide/index.html).


## Licence

Espresso is a community driven project to create a large suite of forward
simulations to enable researchers to get example data without the need to 
understand each individual problem in detail.

Licensing is done individually by each contributor. If a contributor wants to freely share their code example we recommend the MIT licence or a 
2-clause BSD licence. To determine the licence of an existing Espresso
problem, please consult the documentation section of that problem.

All the other core functions of Espresso written by InLab Espresso developer
team are distributed under a 2-clause BSD licence. A copy of this licence is
provided with distributions of the software.

# Xray Tracer

<!-- Please write anything you'd like to explain about the forward problem here -->

In this example, we consider performing X-Ray Tomography (XRT) to image the interior 
of a structure. We assume that the x-rays travel at the same speed regardless of the 
medium through which they are passing, and so their paths are straight lines between 
source and receiver. However, the medium causes the x-rays to attenuate: paths through 
dense objects (such as bones!) arrive at the receiver with far less energy than they 
had at the source. Thus, by analysing the attenuation along many different paths, we 
can build up a picture of the interior of an object.

Specifically, we will assume that the intensity at the receiver, $I_{rec}$, is 
related to the intensity at the source, $I_{src}$ by 
$I_{rec} = I_{src}\exp\left\{-\int_\mathrm{path} \mu(\mathbf{x})\,\mathrm{d}\mathbf{l}\right\}$

where $\mu(\mathbf{x})$ is a position-dependent attenuation coefficient. To obtain 
a linear inverse problem, we rewrite this as 
$-\log \frac{I_{rec}}{I_{src}}=\int_\mathrm{path} \mu(\mathbf{x})\,\mathrm{d}\mathbf{l}\,.$ 

We know that 
$\int\left[f(x) + g(x)\right]\,\mathrm{d}x = \int f(x)\,\mathrm{d}x + \int g(x)\,\mathrm{d}x$ 

so we say that integration is a *linear* operation, and hence we can solve the XRT 
problem with linear inverse theory.

We will assume that the object we are interested in is 2-dimensional, so that 
$\mu(\boldsymbol{x}) = \mu(x,y)$. If we discretize this model, with $N_x$ cells in the 
$x$-direction and $N_y$ cells in the $y$-direction, we can express $\mu(x,y)$ as an 
$N_x \times N_y$ vector $\boldsymbol{\mu}$. This is related to the data by
$d_i = A_{ij}\mu_j$

where $d_i = -\log {I^{(i)}_{rec}}/{I^{(i)}_{src}}$, and where $A_{ij}$ represents the 
path length in cell $j$ of the discretized model.

# Simple Regression

<!-- Please write anything you'd like to explain about the forward problem here -->

In this test problem, we have 5 small 1D regression (curve-fitting) problems.
Several different forms of basis function are supported: polynomial, Fourier and
disrete.

# Magnetotelluric 1D

## Theoretical background

The magnetotelluric (MT) method is a passive electromagnetic method that uses the fluctuations of the natural electromagnetic field to determine the distribution of the electrical conductivity in the subsurface. When the electric and magnetic fields are measured simultaneously on the surface, their complex ratio (the impedance) can be used to describe the penetration of the EM fields in the Earth, which is dependent on their frequencies and the electrical conductivity of the subsurface. 

The impedance $Z$ is a 4x4 tensor which relates electric ( $E$ ) and magnetic ( $H$ ) fields in the x and y directions in Cartesian coordinates (x, y):

$$
\begin{pmatrix}
E_{x}\\ 
E_{y}
\end{pmatrix} = 
\begin{pmatrix}
Z_{xx} & Z_{xy}\\
Z_{yx} & Z_{yy}  
\end{pmatrix} \cdot
\begin{pmatrix}
H_{x}\\
H_{y} 
\end{pmatrix}
$$


In these examples, we assume that the Earth is 1-D, that there is no lateral variations of the electrical conductivity in the x and y directions, only in the z direction. In that case the impedance tensor simplifies to:

$$
Z = 
\begin{pmatrix}
 0  & Z_{1D}\\
-Z_{1D} & 0
\end{pmatrix} 
$$

Therefore, the response of a 1D layered Earth is $Z_{1D}$, and is defined as a function of frequency. In 1-D, determining $Z$ given the electrical conductivity values of the Earth (the forward model) is done using a recursive approach (Wait, 1954; Pedersen and Hermance, 1986). 

Because of its practicality to visually interpret and analyse the data, it is common to represent the complex impedance tensor by its magnitude (the apparent resistivity) and its phase, defined by:

$$
\rho_{app} = \frac{1}{5f} |Z|^2
$$

$$
\Phi = tan^{-1} \frac{\Im(Z)}{\Re(Z)}
$$

with $f$ the frequency defined in Hz, the apparent resistivity $\rho_{app}$ defined in $\Omega m$ and the phase in degrees. 

Details regarding the MT method can be found in Simpson and Bahr (2005) and Chave and Jones (2012).

As mentioned earlier, the penetration of the EM fields depends on the frequency and the electrical conductivity of the Earth. Lower frequencies will penetrate deeper into the Earth, and conductive material will attenuate faster the EM fields. Therefore, depending on the frequency range available (and the composition of the Earth), the MT method can be used to map the distribution of the electrical conductivity into the Earth from tens of meters to hundreds of kilometres. Programs such as AusLAMP (for example Robertson et al., 2016) aims at imaging the Australia lithosphere and upper mantle using long period MT data, while Audio MT (AMT) and Broad Band MT (BBMT) data are used to image the upper crust (for example Simpson et al., 2021 or Jiang et al., 2022). 

### References

*Chave, A. D., & Jones, A. G. (Eds.). (2012). The magnetotelluric method: Theory and practice. Cambridge University Press.*

*Jiang, W., Duan, J., Doublier, M., Clark, A., Schofield, A., Brodie, R. C., & Goodwin, J. (2022). Application of multiscale magnetotelluric data to mineral exploration: An example from the east Tennant region, Northern Australia. Geophysical Journal International, 229(3), 1628-1645.*

*Pedersen, J., & Hermance, J. F. (1986). Least squares inversion of one-dimensional magnetotelluric data: An assessment of procedures employed by Brown University. Surveys in Geophysics, 8(2), 187-231.*

*Robertson, K., Heinson, G., & Thiel, S. (2016). Lithospheric reworking at the Proterozoic–Phanerozoic transition of Australia imaged using AusLAMP Magnetotelluric data. Earth and Planetary Science Letters, 452, 27-35.*

*Simpson, F., & Bahr, K. (2005). Practical magnetotellurics. Cambridge University Press.*

*Simpson, J., Brown, D.D., Soeffky, P., Kyi, D., Mann, S., Khrapov, A., Duan, J., and Greenwood, M., (2021). Cloncurry Extension Magnetotelluric Survey. GSQ Technical Notes
2021/03.*

*Wait, J. R. (1954). On the relation between telluric currents and the earth's magnetic field. Geophysics, 19(2), 281-289.*

## Examples

Three examples of inversion of MT data are presented here:
- __Example 01__: inversion of a synthetic 3 layers Earth model using a smooth regularization. 
- __Synthetic AMT data__: inversion of a synthetic 5 layers Earth model using a smooth regularization. 
- __Field AMT/BBMT data__: inversion of field AMT/BBMT data from the Coompana Province, South Australia, using a smooth regularization.

# Espresso Machine

Espresso machine contains all the code used for infrastructure.

When Espresso is packaged with the contributed inference problems, we move most of the 
files under this module into it as `espresso._machine`.

This page contains a minimal guide on using them. For more details about contributing to Espresso, check 
our [Contributor Guide](https://geo-espresso.readthedocs.io/en/latest/contributor_guide/index.html).

## Generate new Espresso problem

```console
python new_contribution/create_new_contrb.py <example_name>
```

## Build Espresso with all contributions

```console
python build_package/build.py --validate
```

## Validate a new Espresso contribution (pre/post building)

```console
python build_package/validate.py [--contrib CONTRIBS] [--all] [--pre] [--post]
```

# Receiver Function

<!-- Please write anything you'd like to explain about the forward problem here -->

"Receiver functions" are a class of seismic data used to study discontinuities (layering) in the Earth's crust. At each discontinuity, P-to-S conversions occur, introducing complexity in the waveform. By deconvolving horizontal- and vertical-channel waveforms from earthquakes at teleseismic distances, we can isolate information about these conversions, and hence learn about the crustal structure. This deconvolved signal is the receiver function, and has a highly non-linear dependence on the local crustal properties.

# FM Wavefront Tracer

<!-- Please write anything you'd like to explain about the forward problem here -->

The wave front tracker routines solves boundary value ray tracing problems into 2D heterogeneous wavespeed media, defined by continuously varying velocity model calculated by 2D cubic B-splines.

## Fast Marching wavefront tracking
 
The method used here is *Fast Marching wavefront tracking*. In this algorithm the entire first arriving wavefronts from each source are calculated across the entire model in the form of a *travel time field* one per source. Travel times and ray paths are then calculated by tracing rays back from a desired receiver position to the source along the perpendicular to the wavefronts. This uses the *Fast Marching method* which is stable in highly heterogeneous velocity models. Here we implement a version of Fast Marching with source grid refinement for improved accuracy, as described in the papers below. 

*Rawlinson, N., de Kool, M. and Sambridge, M., 2006. "Seismic wavefront tracking in 3-D heterogeneous media: applications with multiple data classes", Explor. Geophys., 37, 322-330.*

*de Kool, M., Rawlinson, N. and Sambridge, M. 2006. "A practical grid based method for tracking multiple refraction and reflection phases in 3D heterogeneous media", Geophys. J. Int., 167, 253-270.*

The python implementation here is a *wrapper* around the FMM code `fm2dss.f90` of Nick Rawlinson.


## Theoretical background

The goal in travel-time tomography is to infer details about the velocity structure of a medium, given measurements of the minimum time taken for a wave to propagate from source to receiver. For seismic travel times, as we change our model, the route of the fastest path from source to receiver also changes. This makes the problem nonlinear, as raypaths also depend on the sought after velocity or slowness model. 

Provided the 'true' velocity structure is not *too* dissimilar from our initial guess, travel-time tomography can be treated as a weakly non-linear problem. In this notebook we optionally treat the ray paths as fixed, and so it becomes a linear problem, or calculate rays in the velociuty model.

The travel-time of an individual ray can be computed as 

$$t = \int_\mathrm{path} \frac{1}{v(\mathbf{x})}\,\mathrm{d}\mathbf{x}$$

This points to an additional complication: even for a fixed path, the relationship between velocities and observations is not linear. However, if we define the 'slowness' to be the inverse of velocity, $s(\mathbf{x}) = v^{-1}(\mathbf{x})$, we can write
$$t = \int_\mathrm{path} {s(\mathbf{x})}\,\mathrm{d}\mathbf{x}$$
which *is* linear.


We will assume that the object we are interested in is 2-dimensional slowness field. If we discretize this model, with $N_x$ cells in the $x$-direction and $N_y$ cells in the $y$-direction, we can express $s(\mathbf{x})$ as an $N_x \times N_y$ vector $\boldsymbol{s}$. 

**For the linear case**, this is related to the data by

$$d_i = A_{ij}s_j $$

where $d_i$ is the travel time of the ith path, and where $A_{ij}$ represents the path length in cell $j$ of the discretized model.

**For the nonlinear case**, this is related to the data by

$$\delta d_i = A_{ij}\delta s_j $$

where $\delta d_i$ is the difference in travel time, of the ith path, between the observed time and the travel time in the reference model. Here $A_{ij}$ represents the path length in cell $j$ of the discretized model. The parameters $\delta s_j$ are slowness perturbations to the reference model.


## Library usage

All the methods comply to `geo-espresso` standards. Additionally, you can display 
paths together with the model when running `fmm_instance.plot_model(model, paths=True)`,
where `fmm_instance` is an instance of class `FmmTomography`.

# Confined aquifer slug test example

<!-- Please write anything you'd like to explain about the forward problem here -->

This Inversion Test Problem demonstrates two solutions for the 
time-displacement response at a groundwater well resulting from the application 
of a single well falling head slug test. Both solutions describe the response 
for a fully confined aquifer. These are:

1. Cooper-Bredehoeft-Papadopulos (1967) solution

2. Hvorslev (1951) solution

These solutions assume full aquifer penetration by the tested well. All 
solutions are calculated in the Laplace domain and are inverted to the time 
domain numerically using the De Hoog et al. (1982) algorithm.

# Gravity Density

This Inversion Test Problem explores the gravitational acceleration of a three-dimensional (example 1) 
and pseude-2D (example 2) density model onto specified receiver locations. In this example, 
only the z-component of the gravityational force 
is calculated. The underlying code itself is capable of calculating all three gravity components 
and six gradiometry components and could be modified quickly if there is the need. 

The gravitational acceleration is calculated using Newton's law of universal gravitation: 

$$
    g (r) =- G \frac{ m} {r^2} 
$$

With G being the gravitational constant, r is the distance of the mass
to the receiver and m is the overall mass of the model, which depends on the density $\rho$ and the volume V:

$$
    m = \int_V {\rho(r) dV}
$$

Here, we solve volume integral for the vertical component of $g$ analytically, using the approach by Plouff et al., 1976:

$$
g_z(M,N)=G \rho \sum_{i=1}^2 \sum_{j=1}^2 \sum_{k=1}^2  (-1)^{i+j+k} [tan^{-1} \frac{a_ib_j}{z_k R_{ijk}} - a_i ln(R_{ijk} + b_j) - b_j ln(R_{ijk} + a_i)]
$$

with $R_{ijk}=\sqrt{a_i^2 + b_j^2 + z_k^2}$ and $a_i, b_j, z_k$ being the distances from receiver N to the 
nodes of the current prism M (i.e. grid cell) in x, y, and z directions. It is assumed that $\rho=const.$ within each grid cell. 
For more information, please see the original paper: 

Plouff, D., 1976. *Gravity and magnetic fields of polygonal prisms and application to magnetic terrain corrections.* **Geophysics**, 41(4), pp.727-741

For further reading, see also Nagy et al., 2000:

Nagy, D., Papp, G. and Benedek, J., 2000. *The gravitational potential and its derivatives for the prism.* **Journal of Geodesy**, 74(7), pp.552-560

**Example details:**

 1. **Model:** Density values on a regularly spaced, rectangular grid. Example-model one is a 3D cube of low density (10 $kgm^{-3}$) containing a centrally located high-density cube (1000 $kgm^{-3}$). Example-model two repeats Figure 2 of Last and Kubik, 1983, which means a pseudo-2D model containing zero-density background cells and centrally high-density cells in the shape of a cross (1000 $kgm^{-3}$).

    Last, B.J. and Kubik, K., 1983. *Compact gravity inversion.* **Geophysics**, 48(6), pp.713-721
    
 2. **Returned data:** Gravitational acceleration (vertical component).
    
 3. **Forward:**  The volume integral is solved analytically following the above described approach by Plouff et al., 1976.


<!-- Please write anything you'd like to explain about the forward problem here -->

<!-- Welcome to your new Espresso example!

To complete this contribution, here are some ideas on what to do next:

- [ ] **Modify [README.md](README.md)**. Replace the title above with your test problem name,
   and document anything you'd like to add for this problem. Some recommended parts
   include:
   - What this test problem is about
   - What you would recommend inversion practitioners to notice
   - etc.
- [ ] **Modify [metadata.yml](metadata.yml)**. As the name suggests, this file contains basic
   information about the problem itself, authors, citations, example information and
   other extra information you'd like to include. It's a yaml file so that we can 
   render some of the information in a more structured manner.
- [ ] **Modify [LICENCE](LICENCE)**. The default one we've used is a 2-clauss BSD licence. 
   Feel free to replace the content with a licence that suits you best.
- [ ] **Write code in [gravity_density.py](gravity_density.py) (and [__init__.py](__init__.py) if
   necessary)**. Some basic functions have been defined in the template - these are the
   standard interface we'd like to enforce in Espresso. You'll see
   clearly some functionalities that are required to implement and others that are
   optional.
- [ ] **Validate and build your contribution locally**. We have seperate scripts for 
   validation and packaging.
   ```console
   $ python espresso_machine/build_package/validate.py         # to validate your contribution
   $ python espresso_machine/build_package/build.py            # to install updated Espresso in your environment
   $ python espresso_machine/build_package/validate_build.py   # to run both of above together
   ```
- [ ] **Delete / comment out these initial instructions**. They are for your own reference
   so feel free to delete them or comment them out once you've finished the above
   checklist.


## How to test your code

> **Note that you cannot test your code directly inside your example subfolder**, due to
> the relative import inside the contribution file. Check the following for details.

***In order to test your code***, use `contrib` as your working directory and import your contribution
in the following ways.

(Python interactive mode)
```python
$ pwd                            # check you are in the right folder
<path-to-espresso>/contrib
$ python
>>> from gravity_density import ExampleName   # import it this way
```

(Creating temporary Python file)
```python
# file contrib/tmp.py            # create tmp file in the right folder
from gravity_density import ExampleName       # import it this way
``` -->

# Aquifer constant rate discharge pumping test example

<!-- Please write anything you'd like to explain about the forward problem here -->

This Inversion Test Problem demonstrates a range of solutions for the 
time-drawdown response at an observation well resulting from the application of
a constant rate discharge pumping test at an adjacent production well. Each 
solution describes the response for a unique aquifer type. These are:

1. Confined aquifer solution (Theis, 1935)

2. Leaky aquifer solution featuring no aquitard storage (Hantush and Jacob, 1955)

3. Leaky aquifer solution featuring aquitard storage (Hantush, 1960)

4. Fractured rock aquifer solution (Barker, 1988)

These solutions assume full aquifer penetration by both the production and 
observation wells. All solutions are calculated in the Laplace domain and are
inverted to the time domain numerically using the De Hoog et al. (1982) 
algorithm.

# Example Name Title


<!-- Welcome to your new Espresso example! -->

<!-- Following along with the 
[contributor guide](http://localhost:8000/contributor_guide/new_contrib.html#add-your-own-espresso-problem) 
to get started. -->

<!-- Please write anything you'd like to explain about the forward problem here -->

subroutine whichcell(point,voro,npt,npt_max,ind)
real point,voro(npt_max,3)
integer npt,ind,i,npt_max

ind=1
do i=1,npt
!write(*,*)point,abs(point-voro(i,1)),abs(point-voro(ind,1))
    if (abs(point-voro(i,1))<abs(point-voro(ind,1))) then
        ind=i
    endif
 !   write(*,*)ind
enddo
return
end

c-------------------------------------------------------------------
c
c     Numerical Recipes random number generator
c
c ----------------------------------------------------------------------------

      FUNCTION ran3(idum)
      INTEGER idum
      INTEGER MBIG,MSEED,MZ
c     REAL MBIG,MSEED,MZ
      REAL ran3,FAC
      PARAMETER (MBIG=1000000000,MSEED=161803398,MZ=0,FAC=1./MBIG)
c     PARAMETER (MBIG=4000000.,MSEED=1618033.,MZ=0.,FAC=1./MBIG)
      INTEGER i,iff,ii,inext,inextp,k
      INTEGER mj,mk,ma(55)
c     REAL mj,mk,ma(55)
      SAVE iff,inext,inextp,ma
      DATA iff /0/
c     write(*,*)' idum ',idum
      if(idum.lt.0.or.iff.eq.0)then
         iff=1
         mj=MSEED-iabs(idum)
         mj=mod(mj,MBIG)
         ma(55)=mj
         mk=1
         do 11 i=1,54
            ii=mod(21*i,55)
            ma(ii)=mk
            mk=mj-mk
            if(mk.lt.MZ)mk=mk+MBIG
            mj=ma(ii)
c           write(*,*)' idum av',idum
 11      continue
         do 13 k=1,4
         do 12 i=1,55
            ma(i)=ma(i)-ma(1+mod(i+30,55))
            if(ma(i).lt.MZ)ma(i)=ma(i)+MBIG
 12      continue
 13      continue
c        write(*,*)' idum ap',idum
         inext=0
         inextp=31
         idum=1
      endif
c     write(*,*)' idum app ',idum
      inext=inext+1
      if(inext.eq.56)inext=1
      inextp=inextp+1
      if(inextp.eq.56)inextp=1
      mj=ma(inext)-ma(inextp)
      if(mj.lt.MZ)mj=mj+MBIG
      ma(inext)=mj
      ran3=mj*FAC
c     write(*,*)' idum ',idum
      return
      END

subroutine voro2qmodel(voro,npt,npt_max,d_min,d_max,beta,h,vpvs,qa,qb)

real voro(npt_max,3),d_min,d_max,beta(npt_max),vpvs(npt_max),qa(npt_max),qb(npt_max),maxx,minn,summ,h(npt_max) 
integer npt,ind,i,j,order(npt),npt_max

beta=0
vpvs=0
qa=0
qb=0
h=0

! do i=1,npt
! write(*,*)voro(i,:)
! enddo


ind=1


do i=1,npt
!write(*,*)'ordre',i
	maxx=d_max
	if (i==1) then
		minn=d_min
	else
		minn=voro(order(i-1),1)
	endif
!	write(*,*)minn,maxx
	do j=1,npt
		if ((minn<voro(j,1)).and.(voro(j,1)<maxx)) then
!			write(*,*)minn,voro(j,1),maxx
			ind=j
			maxx=voro(j,1)
!			write(*,*)ind,maxx
		endif
	enddo
	order(i)=ind
! 	write(*,*)ind
! 	write(*,*)
!   	write(*,*)

enddo


summ=0
do i=1,npt-1

h(i)= (voro(order(i),1)+voro(order(i+1),1))/2 - summ
summ = summ + h(i)
beta(i) = voro(order(i),2)
vpvs(i) = voro(order(i),3)

qa(i)= 1450
qb(i)= 600 

enddo

h(npt)=0
beta(npt) = voro(order(npt),2)
vpvs(npt) = voro(order(npt),3)

qa(npt)= 1450
qb(npt)= 600 

return
end

Subroutine RFcalc_nonoise(voro,mtype,fs,gauss_a,water_c,angle,time_shift,ndatar,v60,npt,time,wdata) ! input observer RF, velocity model and return calculated RF
!F2PY INTENT(OUT) :: wdata
!F2PY INTENT(OUT) :: time
!F2PY INTENT(IN) :: voro
!F2PY INTENT(IN) :: mtype
!F2PY INTENT(IN) :: fs
!F2PY INTENT(IN) :: gauss_a
!F2PY INTENT(IN) :: water_c
!F2PY INTENT(IN) :: angle
!F2PY INTENT(IN) :: time_shift
!F2PY INTENT(IN) :: ndatar
!F2PY INTENT(IN) :: v60
!F2PY INTENT(HIDE),DEPEND(voro) :: npt
!F2PY REAL :: voro(npt,3)
implicit none

!------------------------------------------------
! Prior distribution (Bounds odf the model space)
!------------------------------------------------

real, parameter :: d_min = 0
real, parameter :: d_max = 60
      

!--------------------------------------------
! Parameters for Receiver Function
!-------------------------------------------- 

! All parameter converted to input variables 27/06/18

 real fs,gauss_a,water_c,angle,time_shift,v60 
 integer ndatar,mtype
! Parameters are associated with the data vector which is a waveform

! real, parameter :: fs = 25.00       !sampling frequency
! real, parameter :: gauss_a = 2.5    !number 'a' defining the width of 
                                      !the gaussian filter in the deconvolution  
! real, parameter :: water_c = 0.0001 !water level for deconvolution 
! real, parameter :: angle = 35       ! angle of the incoming wave 
! real, parameter :: time_shift = 5   !time shift before the first p pusle 
! integer, parameter :: ndatar = 157  !Number of data points
! integer, parameter :: ndatar = 626  !Number of data points
! real, parameter ::    v60 = 8.043      ! Vs at 60km depth 
! mtype is the indicator for the format of the velocity
!v60 is needed to compute the ray parameter from angle. 

 real, parameter ::    pi = 3.14159265      !don't touch
 real, parameter ::    rad = 0.017453292    !don't touch

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

!***************************************************************

! DECLARATIONS OF VARIABLES

!****************************************************************

real wdata(ndatar),time(ndatar)
real voro(npt,3)
real din,ppara,depth
integer i,npt
real beta(npt),h(npt),vpvs(npt),qa(npt),qb(npt)

!write(*,*)' npt',npt
!write(*,*)' ndatar',ndatar

!**************************************************************

!    Set up reference model 

!**************************************************************

if(mtype.eq.0)then
     call voro2qmodel(voro,npt,npt,d_min,d_max,beta,h,vpvs,qa,qb)
else if(mtype.eq.1)then
     do i=1,npt
        h(i)= voro(i,1) 
        beta(i) = voro(i,2)
        vpvs(i) = voro(i,3)
        qa(i)= 1450
        qb(i)= 600
     enddo
     h(npt)=0
else if(mtype.eq.2)then
     depth = 0.0
     do i=1,npt
        h(i)= voro(i,1) - depth 
        beta(i) = voro(i,2)
        vpvs(i) = voro(i,3)
        qa(i)= 1450
        qb(i)= 600
        depth = voro(i,1)
     enddo
     h(npt)=0
else 
     write(*,*)' Fortran routine RF: Input model type unknown'
     stop
end if
!write(*,*)'mtype = ',mtype

!do i=1,npt
!write(*,*)i,h(i),beta(i),vpvs(i),qa(i),qb(i)
!end do

! Compute RF for current model
ppara=sin(angle*rad)/v60
din=asin(ppara*beta(npt)*vpvs(npt))/rad

call theo(&
          npt, beta, h, vpvs, qa, qb, fs, din,&
          gauss_a, water_c, time_shift, ndatar, wdata )

! write out RF of model

!open(72,file='RF.out',status='replace')
do i=1,ndatar
   time(i) = -time_shift+(i-1)/fs
   !write(72,*)-time_shift+(i-1)/fs,wdata(i)
   !residual(i) = d_obsr(i)-wdata(i) ! return this if we are a subroutine
enddo
!close(72)
return
end
Subroutine RFcalc_noise(voro,mtype,sn,fs,gauss_a,water_c,angle,time_shift,ndatar,v60,seed,npt,time,wdata) ! input observer RF, velocity model and return calculated RF
!F2PY INTENT(OUT) :: wdata
!F2PY INTENT(OUT) :: time
!F2PY INTENT(IN) :: voro
!F2PY INTENT(IN) :: mtype
!F2PY INTENT(IN) :: sn
!F2PY INTENT(IN) :: fs
!F2PY INTENT(IN) :: gauss_a
!F2PY INTENT(IN) :: water_c
!F2PY INTENT(IN) :: angle
!F2PY INTENT(IN) :: time_shift
!F2PY INTENT(IN) :: ndatar
!F2PY INTENT(IN) :: v60
!F2PY INTENT(IN) :: seed
!F2PY INTENT(HIDE),DEPEND(voro) :: npt
!F2PY REAL :: voro(npt,3)
!F2PY REAL :: sn
!F2PY INT :: seed
implicit none

!------------------------------------------------
! Prior distribution (Bounds odf the model space)
!------------------------------------------------

real, parameter :: d_min = 0
real, parameter :: d_max = 60
      

!--------------------------------------------
! Parameters for Receiver Function
!-------------------------------------------- 

! All parameter converted to input variables 27/06/18

 real fs,gauss_a,water_c,angle,time_shift,v60 
 integer ndatar,mtype
!Those parameters are associated with the data vector which is a waveform

! mtype is the indicator for the format of the velocity
!real, parameter :: fs = 25.00        !sampling frequency
!real, parameter :: gauss_a = 2.5    !number 'a' defining the width of 
!the gaussian filter in the deconvolution  
!real, parameter :: water_c = 0.0001 !water level for deconvolution 
!real, parameter :: angle = 35       ! angle of the incoming wave 
!real, parameter :: time_shift = 5   !time shift before the first p pusle 
!integer, parameter :: ndatar = 157  !Number of data points
!integer, parameter :: ndatar = 626  !Number of data points

real, parameter ::    pi = 3.14159265      !don't touch
real, parameter ::    rad = 0.017453292    !don't touch
!real, parameter ::    v60 = 8.043      ! Vs at 60km depth 
!v60 is needed to compute the ray parameter from angle. 

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

!***************************************************************

! DECLARATIONS OF VARIABLES

!****************************************************************

real wdata(ndatar),time(ndatar)
real voro(npt,3)
real sn
real din,ppara
integer i,npt,seed
real beta(npt),h(npt),vpvs(npt),qa(npt),qb(npt)

!**************************************************************

!    Set up reference model 

!**************************************************************

if(mtype.eq.0)then
     call voro2qmodel(voro,npt,npt,d_min,d_max,beta,h,vpvs,qa,qb)
else
     do i=1,npt
        h(i)= voro(i,1) 
        beta(i) = voro(i,2)
        vpvs(i) = voro(i,3)
        qa(i)= 1450
        qb(i)= 600
     enddo
     h(npt)=0
end if

!do i=1,npt
!write(*,*)i,h(i),beta(i),vpvs(i),qa(i),qb(i)
!end do

! set random seed (MS April 2020)
if(seed.ne.1)then
call ran3(-iabs(seed))
end if

! Compute RF for current model
ppara=sin(angle*rad)/v60
din=asin(ppara*beta(npt)*vpvs(npt))/rad

call theo_noise(&
          npt, beta, h, vpvs, qa, qb, fs, din,&
          gauss_a, water_c, time_shift, ndatar, sn, wdata )

! write out RF of model

!open(72,file='RF.out',status='replace')
do i=1,ndatar
   time(i) = -time_shift+(i-1)/fs
   !write(72,*)-time_shift+(i-1)/fs,wdata(i)
   !residual(i) = d_obsr(i)-wdata(i) ! return this if we are a subroutine
enddo
!close(72)
return
end
Subroutine voro2mod(voro,npt,h,beta,vpvs,qa,qb) ! input observer RF, velocity model and return calculated RF
!F2PY INTENT(OUT) :: h
!F2PY INTENT(OUT) :: beta
!F2PY INTENT(OUT) :: vpvs
!F2PY INTENT(OUT) :: qa
!F2PY INTENT(OUT) :: qb
!F2PY INTENT(IN) :: voro
!F2PY INTENT(HIDE),DEPEND(voro) :: npt
!F2PY REAL :: voro(npt,3)
implicit none

!------------------------------------------------
! Prior distribution (Bounds odf the model space)
!------------------------------------------------

real, parameter :: d_min = 0
real, parameter :: d_max = 60
      
!***************************************************************

! DECLARATIONS OF VARIABLES

!****************************************************************

real voro(npt,3)
integer npt
real beta(npt),h(npt),vpvs(npt),qa(npt),qb(npt)

!**************************************************************

!    Set up reference model 

!**************************************************************

call voro2qmodel(voro,npt,npt,d_min,d_max,beta,h,vpvs,qa,qb)

!do i=1,npt
!write(*,*)i,h(i),beta(i),vpvs(i),qa(i),qb(i)
!end do

return
end

      SUBROUTINE svbksb(u,w,v,m,n,mp,np,b,x)
      INTEGER m,mp,n,np,NMAX
      DOUBLE PRECISION b(mp),u(mp,np),v(np,np),w(np),x(np)
      PARAMETER (NMAX=1000)
      INTEGER i,j,jj
      DOUBLE PRECISION s,tmp(NMAX)
      do 12 j=1,n
        s=0.
        if(w(j).ne.0.)then
          do 11 i=1,m
            s=s+u(i,j)*b(i)
11        continue
          s=s/w(j)
        endif
        tmp(j)=s
12    continue
      do 14 j=1,n
        s=0.
        do 13 jj=1,n
          s=s+v(j,jj)*tmp(jj)
13      continue
        x(j)=s
14    continue
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software '%1&9p#!.

      SUBROUTINE four1(data,nn,isign)
      INTEGER isign,nn
      REAL data(2*nn)
      INTEGER i,istep,j,m,mmax,n
      REAL tempi,tempr
      DOUBLE PRECISION theta,wi,wpi,wpr,wr,wtemp
      n=2*nn
      j=1
      do 11 i=1,n,2
        if(j.gt.i)then
          tempr=data(j)
          tempi=data(j+1)
          data(j)=data(i)
          data(j+1)=data(i+1)
          data(i)=tempr
          data(i+1)=tempi
        endif
        m=n/2
1       if ((m.ge.2).and.(j.gt.m)) then
          j=j-m
          m=m/2
        goto 1
        endif
        j=j+m
11    continue
      mmax=2
2     if (n.gt.mmax) then
        istep=2*mmax
        theta=6.28318530717959d0/(isign*mmax)
        wpr=-2.d0*sin(0.5d0*theta)**2
        wpi=sin(theta)
        wr=1.d0
        wi=0.d0
        do 13 m=1,mmax,2
          do 12 i=m,n,istep
            j=i+mmax
            tempr=sngl(wr)*data(j)-sngl(wi)*data(j+1)
            tempi=sngl(wr)*data(j+1)+sngl(wi)*data(j)
            data(j)=data(i)-tempr
            data(j+1)=data(i+1)-tempi
            data(i)=data(i)+tempr
            data(i+1)=data(i+1)+tempi
12        continue
          wtemp=wr
          wr=wr*wpr-wi*wpi+wr
          wi=wi*wpr+wtemp*wpi+wi
13      continue
        mmax=istep
      goto 2
      endif
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software '%1&9p#!.

      subroutine theo_noise(
     &     n, fbeta, h, vps, qa, qb, fs, din, a0, c0, t0,
     &     nd, sn, rx )
******************************************
*     crustal response for layered dissipative medium       *
*     coded by t. shibutani    ( jan. 1990 )                *
******************************************
c
c     **  din(deg),rin(rad) = incident angle of p wave
c     **  vpvs = vp/vs
c     **  qa,qb = p and s attenuations
c     **  n = the number of layers
c     **  fbeta(m) = s velocity in the m-th layer
c     **  h(m) = thickness of the m-th layer
c     **  c0 = parameter of a minimum amplitude level
c     **  a0 = parameter of a gaussian high-cut filter
c     **  rx(1-nb) = synthetic response
c
c
	include 	'rfi_param.inc'

      parameter     ( nlmx = maxsublayer)
      parameter     ( nb = maxdata )
      parameter     ( nb2 = nb/2+1 )

c     parameter     ( nlmx = 100)
c     parameter     ( nb = 1024 )
c     parameter     ( nb2 = nb/2+1 )
c       !!! remarks: if you change the above parameters, you should
c       !!!          also change the corresponding parameters in
c       !!!          the main program and the subroutine "qlayer".
c
c
      real w(nb2), wa(nb2), fai(nb2), gau(nb2),
     &     data(2*nb),
     &     fbeta(nlmx), h(nlmx), vps(nlmx), rho(nlmx),
     &     qa(nlmx), qb(nlmx), rs(nlmx),
     &     rx(maxdata)
c
      complex up(nb2), wp(nb2), usv(nb2), wsv(nb2), vsh(nb2),
     &        cc(nb),
     &        valpha(nlmx), vbeta(nlmx),
     &        yi, cs, cn, ct
c
c     *** parameters ***
      yi=(0.,1.)
      pi=3.141592653
      pi2=pi*2
      rad=180./pi
      !iseed = 1
      frini=0.
      frint=fs/nb
c
      do 110 k=1,nb2
        fk=k-1
        fr=frini+frint*fk
        w(k)=pi2*fr
  110 continue
c
c     *** crustal response for layered q structure ***
c     **  p velocity,s velocity,density,thickness  **
c     **  p and s attenuations, lateral anisotropy  **
c
c	do i=1,n
c	  write(6,'(i3,5f10.3)') i,h(i),fbeta(i),vps(i),qa(i),qb(i)
c	end do
c      write(6,*) 'nd=',nd
c
      do 120 m=1,n
        vbeta(m)=cmplx(fbeta(m))
        va=vps(m)*fbeta(m)
        valpha(m)=cmplx(va)
        rho(m)=2.35+0.036*(va-3.0)**2
        rs(m)=1.0
  120 continue
c
c     **  computation for the case of incident p waves  **
      rin=pi*din/180.
      call qlayer(
     &     1, rin, n, h, valpha, vbeta, rho, qa, qb, rs,
     &     w, up, wp, usv, wsv, vsh )
c
c     * a minimum allowable amplitude level *
      wmax=0.
      do 40 i=1,nb2
        wa(i)=wp(i)*conjg(wp(i))
        wmax=amax1(wmax,wa(i))
   40 continue
      do 50 i=1,nb2
        fai(i)=amax1(wa(i),c0*wmax)
   50 continue
c
c     * a gaussian function to exclude high-frequency noise *
      do 60 i=1,nb2
        gau(i)=exp(-(w(i)/(2*a0))**2)
   60 continue
c
c     * vertical receiver function for absolute amplitude *
c
      do 260 i=1,nb2
        cs=yi*w(i)*t0
        cc(i)=wp(i)*conjg(wp(i))*gau(i)*cexp(cs)/fai(i)
        if (i.ge.2) cc(nb-i+2)=conjg(cc(i))
  260 continue
c
c     * transform back into the time domain *
c
      do 270 i=1,nb
        data(2*i-1)=real(cc(i))
        data(2*i)=aimag(cc(i))
  270 continue
      call four1(data,nb,-1)
c
c     * max amplitude of vertical reciever function *
c
      rvmax=0.
      do 510 i=1,nd
        rvmax=amax1(rvmax,abs(data(2*i-1)/nb))

  510 continue
c
c     * the receiver function in the frequency domain *
c	with noise added
c
      do 160 i=1,nb2
        cs=yi*w(i)*t0
        a1=ran3(iseed)
        a2=ran3(iseed)-0.5
        r1=a1*2.-1.
        if (a2.ge.0.) then
           r2=sqrt(1.-r1**2)
        else
           r2=-sqrt(1.-r1**2)
        end if
        cn=cmplx(r1,r2)
        ct=conjg(up(i))*wp(i)*gau(i)*cexp(cs)/fai(i)
        cc(i)=ct*(1.+sn*cn)
        if (i.ge.2) cc(nb-i+2)=conjg(cc(i))
  160 continue
c
c     * transform back into the time domain *
c
      do 170 i=1,nb
        data(2*i-1)=real(cc(i))
        data(2*i)=aimag(cc(i))
  170 continue
      call four1(data,nb,-1)
c
c     **  radial receiver function ***
c
      do 520 i=1,nd
        rx(i)=data(2*i-1)/nb/rvmax

  520 continue
c      write(6,*) 'rx(71:80)'
c      write(6,*) (rx(i),i=71,80)
c
      return
      end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! TYPE: MODULE
! CODE: FORTRAN 90
! This module declares variable for global use, that is, for
! USE in any subroutine or function or other module. 
! Variables whose values are SAVEd can have their most
! recent values reused in any routine.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
MODULE globalp
IMPLICIT NONE
INTEGER, PARAMETER :: i10=SELECTED_REAL_KIND(10,100)
INTEGER :: checkstat
INTEGER, SAVE :: nvx,nvz,nnx,nnz,nrc,fom,gdx,gdz
INTEGER, SAVE :: vnl,vnr,vnt,vnb,nrnx,nrnz,sgdl,rbint
INTEGER, SAVE :: nnxr,nnzr,asgr
INTEGER, DIMENSION (:,:), ALLOCATABLE :: nsts,nstsr,srs
REAL(KIND=i10), SAVE :: gox,goz,dnx,dnz,dvx,dvz,snb,earth
REAL(KIND=i10), SAVE :: goxd,gozd,dvxd,dvzd,dnxd,dnzd
REAL(KIND=i10), SAVE :: drnx,drnz,gorx,gorz
REAL(KIND=i10), SAVE :: dnxr,dnzr,goxr,gozr
REAL(KIND=i10), DIMENSION (:,:), ALLOCATABLE, SAVE :: velv,veln,velnb
REAL(KIND=i10), DIMENSION (:,:), ALLOCATABLE, SAVE :: ttn,ttnr
REAL(KIND=i10), DIMENSION (:), ALLOCATABLE, SAVE :: rcx,rcz
REAL(KIND=i10), PARAMETER :: pi=3.1415926535898
!
! nvx,nvz = B-spline vertex values
! dvx,dvz = B-spline vertex separation
! velv(i,j) = velocity values at control points
! nnx,nnz = Number of nodes of grid in x and z
! nnxr,nnzr = Number of nodes of refined grid in x and z
! gox,goz = Origin of grid (theta,phi)
! goxr, gozr = Origin of refined grid (theta,phi)
! dnx,dnz = Node separation of grid in  x and z
! dnxr,dnzr = Node separation of refined grid in x and z
! veln(i,j) = velocity values on a refined grid of nodes
! velnb(i,j) = Backup of veln required for source grid refinement
! ttn(i,j) = traveltime field on the refined grid of nodes
! ttnr(i,j) = ttn for refined grid
! nsts(i,j) = node status (-1=far,0=alive,>0=close)
! nstsr(i,j) = nsts for refined grid
! checkstat = check status of memory allocation
! fom = use first-order(0) or mixed-order(1) scheme
! snb = Maximum size of narrow band as fraction of nnx*nnz
! nrc = number of receivers
! rcx(i),rcz(i) = (x,z) coordinates of receivers
! earth = radius of Earth (in km)
! goxd,gozd = gox,goz in degrees
! dvxd,dvzd = dvx,dvz in degrees
! dnzd,dnzd = dnx,dnz in degrees
! gdx,gdz = grid dicing in x and z
! vnl,vnr,vnb,vnt = Bounds of refined grid
! nrnx,nrnz = Number of nodes in x and z for refined grid
! gorx,gorz = Grid origin of refined grid
! sgdl = Source grid dicing level
! rbint = Ray-boundary intersection (0=no, 1=yes).
! asgr = Apply source grid refinement (0=no,1=yes)
! srs = Source-receiver status (0=no path, 1=path exists)
!
END MODULE globalp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! TYPE: MODULE
! CODE: FORTRAN 90
! This module contains all the subroutines used to calculate
! the first-arrival traveltime field through the grid.
! Subroutines are:
! (1) travel
! (2) fouds1
! (3) fouds2
! (4) addtree
! (5) downtree
! (6) updtree
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
MODULE traveltime
USE globalp
IMPLICIT NONE
INTEGER ntr
TYPE backpointer
   INTEGER(KIND=2) :: px,pz
END TYPE backpointer
TYPE(backpointer), DIMENSION (:), ALLOCATABLE :: btg
!
! btg = backpointer to relate grid nodes to binary tree entries
! px = grid-point in x
! pz = grid-point in z
! ntr = number of entries in binary tree
!

CONTAINS

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! TYPE: SUBROUTINE
! CODE: FORTRAN 90
! This subroutine is passed the location of a source, and from
! this point the first-arrival traveltime field through the
! velocity grid is determined.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE travel(scx,scz,urg)
IMPLICIT NONE
INTEGER :: isx,isz,sw,i,j,ix,iz,urg,swrg
REAL(KIND=i10) :: scx,scz,vsrc,dsx,dsz,ds
REAL(KIND=i10), DIMENSION (2,2) :: vss
! isx,isz = grid cell indices (i,j,k) which contains source
! scx,scz = (r,x,y) location of source
! sw = a switch (0=off,1=on)
! ix,iz = j,k position of "close" point with minimum traveltime
! maxbt = maximum size of narrow band binary tree
! rd2,rd3 = substitution variables
! vsrc = velocity at source
! vss = velocity at nodes surrounding source
! dsx, dsz = distance from source to cell boundary in x and z
! ds = distance from source to nearby node
! urg = use refined grid (0=no,1=yes,2=previously used)
! swrg = switch to end refined source grid computation
!
! The first step is to find out where the source resides
! in the grid of nodes. The cell in which it resides is
! identified by the "north-west" node of the cell. If the
! source lies on the edge or corner (a node) of the cell, then
! this scheme still applies.
!
isx=INT((scx-gox)/dnx)+1
isz=INT((scz-goz)/dnz)+1
sw=0
IF(isx.lt.1.or.isx.gt.nnx)sw=1
IF(isz.lt.1.or.isz.gt.nnz)sw=1
IF(sw.eq.1)then
   isx=90.0-isx*180.0/pi
   isz=isz*180.0/pi
   WRITE(6,*)"Source lies outside bounds of model (lat,long)= ",isx,isz
   WRITE(6,*)"TERMINATING PROGRAM!!!"
   STOP
ENDIF
IF(isx.eq.nnx)isx=isx-1
IF(isz.eq.nnz)isz=isz-1
!
! Set all values of nsts to -1 if beginning from a source
! point.
!
IF(urg.NE.2)nsts=-1
!
! set initial size of binary tree to zero
!
ntr=0
IF(urg.EQ.2)THEN
!
!  In this case, source grid refinement has been applied, so
!  the initial narrow band will come from resampling the
!  refined grid.
!
   DO i=1,nnx
      DO j=1,nnz
         IF(nsts(j,i).GT.0)THEN
            CALL addtree(j,i)
         ENDIF
      ENDDO
   ENDDO
ELSE 
!
!  In general, the source point need not lie on a grid point.
!  Bi-linear interpolation is used to find velocity at the
!  source point.
!
   nsts=-1
   DO i=1,2
      DO j=1,2
         vss(i,j)=veln(isz-1+j,isx-1+i)
      ENDDO
   ENDDO
   dsx=(scx-gox)-(isx-1)*dnx
   dsz=(scz-goz)-(isz-1)*dnz
   CALL bilinear(vss,dsx,dsz,vsrc)
!
!  Now find the traveltime at the four surrounding grid points. This
!  is calculated approximately by assuming the traveltime from the
!  source point to each node is equal to the the distance between
!  the two points divided by the average velocity of the points
!
   DO i=1,2
      DO j=1,2
         ds=SQRT((dsx-(i-1)*dnx)**2+(dsz-(j-1)*dnz)**2)
         ttn(isz-1+j,isx-1+i)=2.0*ds/(vss(i,j)+vsrc)
         CALL addtree(isz-1+j,isx-1+i)
      ENDDO
   ENDDO
ENDIF
!
! Now calculate the first-arrival traveltimes at the
! remaining grid points. This is done via a loop which
! repeats the procedure of finding the first-arrival
! of all "close" points, adding it to the set of "alive"
! points and updating the points surrounding the new "alive"
! point. The process ceases when the binary tree is empty,
! in which case all grid points are "alive".
!
DO WHILE(ntr.gt.0)
!
! First, check whether source grid refinement is
! being applied; if so, then there is a special
! exit condition.
!
IF(urg.EQ.1)THEN
   ix=btg(1)%px
   iz=btg(1)%pz
   swrg=0
   IF(ix.EQ.1)THEN
      IF(vnl.NE.1)swrg=1
   ENDIF
   IF(ix.EQ.nnx)THEN
      IF(vnr.NE.nnx)swrg=1
   ENDIF
   IF(iz.EQ.1)THEN
      IF(vnt.NE.1)swrg=1
   ENDIF
   IF(iz.EQ.nnz)THEN
      IF(vnb.NE.nnz)swrg=1
   ENDIF
   IF(swrg.EQ.1)THEN
      nsts(iz,ix)=0
      EXIT
   ENDIF
ENDIF
!
! Set the "close" point with minimum traveltime
! to "alive"
!
   ix=btg(1)%px
   iz=btg(1)%pz
   nsts(iz,ix)=0
!
! Update the binary tree by removing the root and
! sweeping down the tree.
!
   CALL downtree
!
! Now update or find values of up to four grid points
! that surround the new "alive" point.
!
! Test points that vary in x
!
   DO i=ix-1,ix+1,2
      IF(i.ge.1.and.i.le.nnx)THEN
         IF(nsts(iz,i).eq.-1)THEN
!
! This option occurs when a far point is added to the list
! of "close" points
!
            IF(fom.eq.0)THEN
               CALL fouds1(iz,i)
            ELSE
               CALL fouds2(iz,i)
            ENDIF
            CALL addtree(iz,i)
         ELSE IF(nsts(iz,i).gt.0)THEN
!
! This happens when a "close" point is updated
!
            IF(fom.eq.0)THEN
               CALL fouds1(iz,i)
            ELSE
               CALL fouds2(iz,i)
            ENDIF
            CALL updtree(iz,i)
         ENDIF
      ENDIF
   ENDDO
!
! Test points that vary in z
!
   DO i=iz-1,iz+1,2
      IF(i.ge.1.and.i.le.nnz)THEN
         IF(nsts(i,ix).eq.-1)THEN
!
! This option occurs when a far point is added to the list
! of "close" points
!
            IF(fom.eq.0)THEN
               CALL fouds1(i,ix)
            ELSE
               CALL fouds2(i,ix)
            ENDIF
            CALL addtree(i,ix)
         ELSE IF(nsts(i,ix).gt.0)THEN
!
! This happens when a "close" point is updated
!
            IF(fom.eq.0)THEN
               CALL fouds1(i,ix)
            ELSE
               CALL fouds2(i,ix)
            ENDIF
            CALL updtree(i,ix)
         ENDIF
      ENDIF
   ENDDO
ENDDO
END SUBROUTINE travel

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! TYPE: SUBROUTINE
! CODE: FORTRAN 90
! This subroutine calculates a trial first-arrival traveltime
! at a given node from surrounding nodes using the
! First-Order Upwind Difference Scheme (FOUDS) of
! Sethian and Popovici (1999).
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE fouds1(iz,ix)
IMPLICIT NONE
INTEGER :: j,k,ix,iz,tsw1,swsol
REAL(KIND=i10) :: trav,travm,slown,tdsh,tref
REAL(KIND=i10) :: a,b,c,u,v,em,ri,risti
REAL(KIND=i10) :: rd1
!
! ix = NS position of node coordinate for determination
! iz = EW vertical position of node coordinate for determination
! trav = traveltime calculated for trial node
! travm = minimum traveltime calculated for trial node
! slown = slowness at (iz,ix)
! tsw1 = traveltime switch (0=first time,1=previously)
! a,b,c,u,v,em = Convenience variables for solving quadratic
! tdsh = local traveltime from neighbouring node
! tref = reference traveltime at neighbouring node
! ri = Radial distance
! risti = ri*sin(theta) at point (iz,ix)
! rd1 = dummy variable
! swsol = switch for solution (0=no solution, 1=solution)
!
! Inspect each of the four quadrants for the minimum time
! solution.
!
tsw1=0
slown=1.0/veln(iz,ix)
ri=earth
risti=ri*sin(gox+(ix-1)*dnx)
DO j=ix-1,ix+1,2
   DO k=iz-1,iz+1,2 
      IF(j.GE.1.AND.j.LE.nnx)THEN
         IF(k.GE.1.AND.k.LE.nnz)THEN
!
!           There are seven solution options in
!           each quadrant.
!
            swsol=0
            IF(nsts(iz,j).EQ.0)THEN
               swsol=1
               IF(nsts(k,ix).EQ.0)THEN
                  u=ri*dnx
                  v=risti*dnz
                  em=ttn(k,ix)-ttn(iz,j)
                  a=u**2+v**2
                  b=-2.0*u**2*em
                  c=u**2*(em**2-v**2*slown**2)
                  tref=ttn(iz,j)
               ELSE
                  a=1.0
                  b=0.0
                  c=-slown**2*ri**2*dnx**2
                  tref=ttn(iz,j)
               ENDIF
            ELSE IF(nsts(k,ix).EQ.0)THEN
               swsol=1
               a=1.0
               b=0.0
               c=-(slown*risti*dnz)**2
               tref=ttn(k,ix)
            ENDIF
!
!           Now find the solution of the quadratic equation
!
            IF(swsol.EQ.1)THEN
               rd1=b**2-4.0*a*c
               IF(rd1.LT.0.0)rd1=0.0
               tdsh=(-b+sqrt(rd1))/(2.0*a)
               trav=tref+tdsh
               IF(tsw1.EQ.1)THEN
                  travm=MIN(trav,travm)
               ELSE
                  travm=trav
                  tsw1=1
                ENDIF
            ENDIF
         ENDIF
      ENDIF
   ENDDO
ENDDO
ttn(iz,ix)=travm
END SUBROUTINE fouds1

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! TYPE: SUBROUTINE
! CODE: FORTRAN 90
! This subroutine calculates a trial first-arrival traveltime
! at a given node from surrounding nodes using the
! Mixed-Order (2nd) Upwind Difference Scheme (FOUDS) of
! Popovici and Sethian (2002).
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE fouds2(iz,ix)
IMPLICIT NONE
INTEGER :: j,k,j2,k2,ix,iz,tsw1
INTEGER :: swj,swk,swsol
REAL(KIND=i10) :: trav,travm,slown,tdsh,tref,tdiv
REAL(KIND=i10) :: a,b,c,u,v,em,ri,risti,rd1
!
! ix = NS position of node coordinate for determination
! iz = EW vertical position of node coordinate for determination
! trav = traveltime calculated for trial node
! travm = minimum traveltime calculated for trial node
! slown = slowness at (iz,ix)
! tsw1 = traveltime switch (0=first time,1=previously)
! a,b,c,u,v,em = Convenience variables for solving quadratic
! tdsh = local traveltime from neighbouring node
! tref = reference traveltime at neighbouring node
! ri = Radial distance
! risti = ri*sin(theta) at point (iz,ix)
! swj,swk = switches for second order operators
! tdiv = term to divide tref by depending on operator order
! swsol = switch for solution (0=no solution, 1=solution)
!
! Inspect each of the four quadrants for the minimum time
! solution.
!
tsw1=0
slown=1.0/veln(iz,ix)
ri=earth
risti=ri*sin(gox+(ix-1)*dnx)
DO j=ix-1,ix+1,2
   IF(j.GE.1.AND.j.LE.nnx)THEN
      swj=-1
      IF(j.eq.ix-1)THEN
         j2=j-1
         IF(j2.GE.1)THEN
            IF(nsts(iz,j2).EQ.0)swj=0
         ENDIF
      ELSE
         j2=j+1
         IF(j2.LE.nnx)THEN
            IF(nsts(iz,j2).EQ.0)swj=0
         ENDIF
      ENDIF
      IF(nsts(iz,j).EQ.0.AND.swj.EQ.0)THEN
         swj=-1
         IF(ttn(iz,j).GT.ttn(iz,j2))THEN
            swj=0
         ENDIF
      ELSE
         swj=-1
      ENDIF
      DO k=iz-1,iz+1,2
         IF(k.GE.1.AND.k.LE.nnz)THEN
            swk=-1
            IF(k.eq.iz-1)THEN
               k2=k-1
               IF(k2.GE.1)THEN
                  IF(nsts(k2,ix).EQ.0)swk=0
               ENDIF
            ELSE
               k2=k+1
               IF(k2.LE.nnz)THEN
                  IF(nsts(k2,ix).EQ.0)swk=0
               ENDIF
            ENDIF
            IF(nsts(k,ix).EQ.0.AND.swk.EQ.0)THEN
               swk=-1
               IF(ttn(k,ix).GT.ttn(k2,ix))THEN
                  swk=0
               ENDIF
            ELSE
               swk=-1
            ENDIF
!
!           There are 8 solution options in
!           each quadrant.
!
            swsol=0
            IF(swj.EQ.0)THEN
               swsol=1
               IF(swk.EQ.0)THEN
                  u=2.0*ri*dnx
                  v=2.0*risti*dnz
                  em=4.0*ttn(iz,j)-ttn(iz,j2)-4.0*ttn(k,ix)
                  em=em+ttn(k2,ix)
                  a=v**2+u**2
                  b=2.0*em*u**2
                  c=u**2*(em**2-slown**2*v**2)
                  tref=4.0*ttn(iz,j)-ttn(iz,j2)
                  tdiv=3.0
               ELSE IF(nsts(k,ix).EQ.0)THEN
                  u=risti*dnz
                  v=2.0*ri*dnx
                  em=3.0*ttn(k,ix)-4.0*ttn(iz,j)+ttn(iz,j2)
                  a=v**2+9.0*u**2
                  b=6.0*em*u**2
                  c=u**2*(em**2-slown**2*v**2)
                  tref=ttn(k,ix)
                  tdiv=1.0
               ELSE
                  u=2.0*ri*dnx
                  a=1.0
                  b=0.0
                  c=-u**2*slown**2
                  tref=4.0*ttn(iz,j)-ttn(iz,j2)
                  tdiv=3.0
               ENDIF
            ELSE IF(nsts(iz,j).EQ.0)THEN
               swsol=1
               IF(swk.EQ.0)THEN
                  u=ri*dnx
                  v=2.0*risti*dnz
                  em=3.0*ttn(iz,j)-4.0*ttn(k,ix)+ttn(k2,ix)
                  a=v**2+9.0*u**2
                  b=6.0*em*u**2
                  c=u**2*(em**2-v**2*slown**2)
                  tref=ttn(iz,j)
                  tdiv=1.0
               ELSE IF(nsts(k,ix).EQ.0)THEN
                  u=ri*dnx
                  v=risti*dnz
                  em=ttn(k,ix)-ttn(iz,j)
                  a=u**2+v**2
                  b=-2.0*u**2*em
                  c=u**2*(em**2-v**2*slown**2)
                  tref=ttn(iz,j)
                  tdiv=1.0
               ELSE
                  a=1.0
                  b=0.0
                  c=-slown**2*ri**2*dnx**2
                  tref=ttn(iz,j)
                  tdiv=1.0
               ENDIF
            ELSE
               IF(swk.EQ.0)THEN
                  swsol=1
                  u=2.0*risti*dnz
                  a=1.0
                  b=0.0
                  c=-u**2*slown**2
                  tref=4.0*ttn(k,ix)-ttn(k2,ix)
                  tdiv=3.0
               ELSE IF(nsts(k,ix).EQ.0)THEN
                  swsol=1
                  a=1.0
                  b=0.0
                  c=-slown**2*risti**2*dnz**2
                  tref=ttn(k,ix)
                  tdiv=1.0
               ENDIF
            ENDIF
!
!           Now find the solution of the quadratic equation
!
            IF(swsol.EQ.1)THEN
               rd1=b**2-4.0*a*c
               IF(rd1.LT.0.0)rd1=0.0
               tdsh=(-b+sqrt(rd1))/(2.0*a)
               trav=(tref+tdsh)/tdiv
               IF(tsw1.EQ.1)THEN
                  travm=MIN(trav,travm)
               ELSE
                  travm=trav
                  tsw1=1
               ENDIF
            ENDIF
         ENDIF
      ENDDO
   ENDIF
ENDDO
ttn(iz,ix)=travm
END SUBROUTINE fouds2

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! TYPE: SUBROUTINE
! CODE: FORTRAN 90
! This subroutine adds a value to the binary tree by
! placing a value at the bottom and pushing it up
! to its correct position.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE addtree(iz,ix)
IMPLICIT NONE
INTEGER :: ix,iz,tpp,tpc
TYPE(backpointer) :: exch
!
! ix,iz = grid position of new addition to tree
! tpp = tree position of parent
! tpc = tree position of child
! exch = dummy to exchange btg values
!
! First, increase the size of the tree by one.
!
ntr=ntr+1
!
! Put new value at base of tree
!
nsts(iz,ix)=ntr
btg(ntr)%px=ix
btg(ntr)%pz=iz
!
! Now filter the new value up to its correct position
!
tpc=ntr
tpp=tpc/2
DO WHILE(tpp.gt.0)
   IF(ttn(iz,ix).lt.ttn(btg(tpp)%pz,btg(tpp)%px))THEN
      nsts(iz,ix)=tpp
      nsts(btg(tpp)%pz,btg(tpp)%px)=tpc
      exch=btg(tpc)
      btg(tpc)=btg(tpp)
      btg(tpp)=exch
      tpc=tpp
      tpp=tpc/2
   ELSE
      tpp=0
   ENDIF
ENDDO
END SUBROUTINE addtree

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! TYPE: SUBROUTINE
! CODE: FORTRAN 90
! This subroutine updates the binary tree after the root
! value has been used. The root is replaced by the value
! at the bottom of the tree, which is then filtered down
! to its correct position. This ensures that the tree remains
! balanced.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE downtree
IMPLICIT NONE
INTEGER :: tpp,tpc
REAL(KIND=i10) :: rd1,rd2
TYPE(backpointer) :: exch
!
! tpp = tree position of parent
! tpc = tree position of child
! exch = dummy to exchange btg values
! rd1,rd2 = substitution variables
!
! Replace root of tree with its last value
!
IF(ntr.EQ.1)THEN
   ntr=ntr-1
   RETURN
ENDIF
nsts(btg(ntr)%pz,btg(ntr)%px)=1
btg(1)=btg(ntr)
!
! Reduce size of tree by one
!
ntr=ntr-1
!
! Now filter new root down to its correct position
!
tpp=1
tpc=2*tpp
DO WHILE(tpc.lt.ntr)
!
! Check which of the two children is smallest - use the smallest
!
   rd1=ttn(btg(tpc)%pz,btg(tpc)%px)
   rd2=ttn(btg(tpc+1)%pz,btg(tpc+1)%px)
   IF(rd1.gt.rd2)THEN
      tpc=tpc+1
   ENDIF
!
!  Check whether the child is smaller than the parent; if so, then swap,
!  if not, then we are done
!
   rd1=ttn(btg(tpc)%pz,btg(tpc)%px)
   rd2=ttn(btg(tpp)%pz,btg(tpp)%px)
   IF(rd1.lt.rd2)THEN
      nsts(btg(tpp)%pz,btg(tpp)%px)=tpc
      nsts(btg(tpc)%pz,btg(tpc)%px)=tpp
      exch=btg(tpc)
      btg(tpc)=btg(tpp)
      btg(tpp)=exch
      tpp=tpc
      tpc=2*tpp
   ELSE
      tpc=ntr+1
   ENDIF
ENDDO
!
! If ntr is an even number, then we still have one more test to do
!
IF(tpc.eq.ntr)THEN
   rd1=ttn(btg(tpc)%pz,btg(tpc)%px)
   rd2=ttn(btg(tpp)%pz,btg(tpp)%px)
   IF(rd1.lt.rd2)THEN
      nsts(btg(tpp)%pz,btg(tpp)%px)=tpc
      nsts(btg(tpc)%pz,btg(tpc)%px)=tpp
      exch=btg(tpc)
      btg(tpc)=btg(tpp)
      btg(tpp)=exch
   ENDIF
ENDIF
END SUBROUTINE downtree

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! TYPE: SUBROUTINE
! CODE: FORTRAN 90
! This subroutine updates a value on the binary tree. The FMM
! should only produce updated values that are less than their
! prior values.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE updtree(iz,ix)
IMPLICIT NONE
INTEGER :: ix,iz,tpp,tpc
TYPE(backpointer) :: exch
!
! ix,iz = grid position of new addition to tree
! tpp = tree position of parent
! tpc = tree position of child
! exch = dummy to exchange btg values
!
! Filter the updated value to its correct position
!
tpc=nsts(iz,ix)
tpp=tpc/2
DO WHILE(tpp.gt.0)
   IF(ttn(iz,ix).lt.ttn(btg(tpp)%pz,btg(tpp)%px))THEN
      nsts(iz,ix)=tpp
      nsts(btg(tpp)%pz,btg(tpp)%px)=tpc
      exch=btg(tpc)
      btg(tpc)=btg(tpp)
      btg(tpp)=exch
      tpc=tpp
      tpp=tpc/2
   ELSE
      tpp=0
   ENDIF
ENDDO
END SUBROUTINE updtree

END MODULE traveltime

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! MAIN PROGRAM
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! TYPE: PROGRAM   
! CODE: FORTRAN 90
! This program is designed to implement the Fast Marching
! Method (FMM) for calculating first-arrival traveltimes
! through a 2-D continuous velocity medium in spherical shell
! coordinates (x=theta or latitude, z=phi or longitude). 
! It is written in Fortran 90, although it is probably more 
! accurately  described as Fortran 77 with some of the Fortran 90
! extensions.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
PROGRAM fmmin2d
USE globalp
USE traveltime
IMPLICIT NONE
CHARACTER (LEN=30) :: sources,receivers,grid,frechet
CHARACTER (LEN=30) :: travelt,rtravel,wrays,otimes,cdum
INTEGER :: i,j,k,l,nsrc,wttf,fsrt,wrgf,cfd,tnr,urg
INTEGER :: sgs,isx,isz,sw,idm1,idm2,nnxb,nnzb
INTEGER :: ogx,ogz,grdfx,grdfz,maxbt
REAL(KIND=i10) :: x,z,goxb,gozb,dnxb,dnzb
REAL(KIND=i10), DIMENSION (:), ALLOCATABLE :: scx,scz
!
! sources = File containing source locations
! receivers = File containing receiver locations
! grid = File containing grid of velocity vertices for
!        resampling on a finer grid with cubic B-splines
! frechet = output file containing matrix of frechet derivatives
! travelt = File name for storage of traveltime field
! wttf = Write traveltimes to file? (0=no,>0=source id)
! fom = Use first-order(0) or mixed-order(1) scheme
! nsrc = number of sources
! scx,scz = source location in r,x,z
! x,z = temporary variables for source location
! fsrt = find source-receiver traveltimes? (0=no,1=yes)
! rtravel = output file for source-receiver traveltimes
! cdum = dummy character variable
! wrgf = write ray geometries to file? (<0=all,0=no,>0=source id.)
! wrays = file containing raypath geometries
! cfd = calculate Frechet derivatives? (0=no, 1=yes)
! tnr = total number of receivers
! sgs = Extent of refined source grid
! isx,isz = cell containing source
! nnxb,nnzb = Backup for nnz,nnx
! goxb,gozb = Backup for gox,goz
! dnxb,dnzb = Backup for dnx,dnz
! ogx,ogz = Location of refined grid origin
! gridfx,grdfz = Number of refined nodes per cell
! urg = use refined grid (0=no,1=yes,2=previously used)
! maxbt = maximum size of narrow band binary tree
! otimes = file containing source-receiver association information
!
OPEN(UNIT=10,FILE='fm2dss.in',STATUS='old')
READ(10,1)cdum
READ(10,1)cdum
READ(10,1)cdum
READ(10,1)sources
READ(10,1)receivers
READ(10,1)otimes
READ(10,1)grid
READ(10,*)gdx,gdz
READ(10,*)asgr
READ(10,*)sgdl,sgs
READ(10,*)earth
READ(10,*)fom
READ(10,*)snb
READ(10,1)cdum
READ(10,1)cdum
READ(10,1)cdum
READ(10,*)fsrt
READ(10,1)rtravel
READ(10,*)cfd
READ(10,1)frechet
READ(10,*)wttf
READ(10,1)travelt
READ(10,*)wrgf
READ(10,1)wrays
1   FORMAT(a30)
CLOSE(10)
!
! Call a subroutine which reads in the velocity grid
!
CALL gridder(grid)
!
! Read in all source coordinates.
!
Open(UNIT=10,FILE=sources,STATUS='old')
READ(10,*)nsrc
ALLOCATE(scx(nsrc),scz(nsrc), STAT=checkstat)
IF(checkstat > 0)THEN
   WRITE(6,*)'Error with ALLOCATE: PROGRAM fmmin2d: REAL scx,scz'
ENDIF
DO i=1,nsrc
   READ(10,*)scx(i),scz(i)
!
!  Convert source coordinates in degrees to radians
!
   scx(i)=(90.0-scx(i))*pi/180.0
   scz(i)=scz(i)*pi/180.0
ENDDO
CLOSE(10)
!
! Read in all receiver coordinates if required
!
IF(fsrt.eq.1)THEN
   OPEN(UNIT=10,FILE=receivers,status='old')
   READ(10,*)nrc
   ALLOCATE(rcx(nrc),rcz(nrc), STAT=checkstat)
   IF(checkstat > 0)THEN
      WRITE(6,*)'Error with ALLOCATE: PROGRAM fmmin2d: REAL rcx,rcz'
   ENDIF
   DO i=1,nrc
      READ(10,*)rcx(i),rcz(i)
!
!     Convert receiver coordinates in degrees to radians
!
      rcx(i)=(90.0-rcx(i))*pi/180.0
      rcz(i)=rcz(i)*pi/180.0
   ENDDO
   CLOSE(10)
ELSE
   OPEN(UNIT=10,FILE=receivers,status='old')
   READ(10,*)nrc
   CLOSE(10)
ENDIF
!
! Read in source-receiver associations
!
OPEN(UNIT=10,FILE=otimes,status='old')
ALLOCATE(srs(nrc,nsrc), STAT=checkstat)
IF(checkstat > 0)THEN
   WRITE(6,*)'Error with ALLOCATE: PROGRAM fmmin2d: REAL srs'
ENDIF
DO i=1,nsrc
   DO j=1,nrc
      READ(10,*)srs(j,i)
   ENDDO
ENDDO
CLOSE(10)
!
! Now work out, source by source, the first-arrival traveltime
! field plus source-receiver traveltimes
! and ray paths if required. First, allocate memory to the
! traveltime field array
!
ALLOCATE(ttn(nnz,nnx), STAT=checkstat)
IF(checkstat > 0)THEN
   WRITE(6,*)'Error with ALLOCATE: PROGRAM fmmin2d: REAL ttn'
ENDIF
!
! Open file for source-receiver traveltime output if required.
!
IF(fsrt.eq.1)THEN
   OPEN(UNIT=10,FILE=rtravel,STATUS='unknown')
ENDIF
!
! Open file for ray path output if required
!
IF(wrgf.NE.0)THEN
   !OPEN(UNIT=40,FILE=wrays,FORM='unformatted',STATUS='unknown')
   OPEN(UNIT=40,FILE=wrays,STATUS='unknown')
   IF(wrgf.GT.0)THEN
      tnr=nrc
   ELSE
      tnr=nsrc*nrc
   ENDIF
   WRITE(40,*)tnr
   rbint=0
ENDIF
!
! Open file for Frechet derivative output if required.
!
IF(cfd.EQ.1)THEN
   ! OPEN(UNIT=50,FILE=frechet,FORM='unformatted',STATUS='unknown')
   OPEN(UNIT=50,FILE=frechet,STATUS='unknown')
ENDIF
!
! Allocate memory for node status and binary trees
!
ALLOCATE(nsts(nnz,nnx))
maxbt=NINT(snb*nnx*nnz)
ALLOCATE(btg(maxbt))
!
! Loop through all sources and find traveltime fields
!
DO i=1,nsrc
   x=scx(i)
   z=scz(i)
!
!  Begin by computing refined source grid if required
!
   urg=0
   IF(asgr.EQ.1)THEN
!
!     Back up coarse velocity grid to a holding matrix
!
      IF(i.EQ.1)ALLOCATE(velnb(nnz,nnx))
      velnb=veln
      nnxb=nnx
      nnzb=nnz
      dnxb=dnx
      dnzb=dnz
      goxb=gox
      gozb=goz
!
!     Identify nearest neighbouring node to source
!
      isx=INT((x-gox)/dnx)+1
      isz=INT((z-goz)/dnz)+1
      sw=0
      IF(isx.lt.1.or.isx.gt.nnx)sw=1
      IF(isz.lt.1.or.isz.gt.nnz)sw=1
      IF(sw.eq.1)then
         isx=90.0-isx*180.0/pi
         isz=isz*180.0/pi
         WRITE(6,*)"Source lies outside bounds of model (lat,long)= ",isx,isz
         WRITE(6,*)"TERMINATING PROGRAM!!!"
         STOP
      ENDIF
      IF(isx.eq.nnx)isx=isx-1
      IF(isz.eq.nnz)isz=isz-1
!
!     Now find rectangular box that extends outward from the nearest source node
!     to "sgs" nodes away.
!
      vnl=isx-sgs
      IF(vnl.lt.1)vnl=1
      vnr=isx+sgs
      IF(vnr.gt.nnx)vnr=nnx
      vnt=isz-sgs
      IF(vnt.lt.1)vnt=1
      vnb=isz+sgs
      IF(vnb.gt.nnz)vnb=nnz
      nrnx=(vnr-vnl)*sgdl+1
      nrnz=(vnb-vnt)*sgdl+1
      drnx=dvx/REAL(gdx*sgdl)
      drnz=dvz/REAL(gdz*sgdl)
      gorx=gox+dnx*(vnl-1)
      gorz=goz+dnz*(vnt-1)
      nnx=nrnx
      nnz=nrnz
      dnx=drnx
      dnz=drnz
      gox=gorx
      goz=gorz
!
!     Reallocate velocity and traveltime arrays if nnx>nnxb or
!     nnz<nnzb.
!
      IF(nnx.GT.nnxb.OR.nnz.GT.nnzb)THEN
         idm1=nnx
         IF(nnxb.GT.idm1)idm1=nnxb
         idm2=nnz
         IF(nnzb.GT.idm2)idm2=nnzb
         DEALLOCATE(veln,ttn,nsts,btg)
         ALLOCATE(veln(idm2,idm1))
         ALLOCATE(ttn(idm2,idm1))
         ALLOCATE(nsts(idm2,idm1))
         maxbt=NINT(snb*idm1*idm2)
         ALLOCATE(btg(maxbt))
      ENDIF
!
!     Call a subroutine to compute values of refined velocity nodes
!
      CALL bsplrefine
!
!     Compute first-arrival traveltime field through refined grid.
!
      urg=1
      CALL travel(x,z,urg)
!
!     Now map refined grid onto coarse grid.
!
      ALLOCATE(ttnr(nnzb,nnxb))
      ALLOCATE(nstsr(nnzb,nnxb))
      IF(nnx.GT.nnxb.OR.nnz.GT.nnzb)THEN
         idm1=nnx
         IF(nnxb.GT.idm1)idm1=nnxb
         idm2=nnz
         IF(nnzb.GT.idm2)idm2=nnzb
         DEALLOCATE(ttnr,nstsr)
         ALLOCATE(ttnr(idm2,idm1))
         ALLOCATE(nstsr(idm2,idm1))
      ENDIF
      ttnr=ttn
      nstsr=nsts
      ogx=vnl
      ogz=vnt
      grdfx=sgdl
      grdfz=sgdl
      nsts=-1
      DO k=1,nnz,grdfz
         idm1=ogz+(k-1)/grdfz
         DO l=1,nnx,grdfx
            idm2=ogx+(l-1)/grdfx
            nsts(idm1,idm2)=nstsr(k,l)
            IF(nsts(idm1,idm2).GE.0)THEN
               ttn(idm1,idm2)=ttnr(k,l)
            ENDIF
         ENDDO
      ENDDO
!
!     Backup refined grid information
!
      nnxr=nnx
      nnzr=nnz
      goxr=gox
      gozr=goz
      dnxr=dnx
      dnzr=dnz
!
!     Restore remaining values.
!
      nnx=nnxb
      nnz=nnzb
      dnx=dnxb
      dnz=dnzb
      gox=goxb
      goz=gozb
      DO j=1,nnx
         DO k=1,nnz 
            veln(k,j)=velnb(k,j)
         ENDDO
      ENDDO
!
!     Ensure that the narrow band is complete; if
!     not, then some alive points will need to be
!     made close.
!
      DO k=1,nnx
         DO l=1,nnz
            IF(nsts(l,k).EQ.0)THEN
               IF(l-1.GE.1)THEN
                  IF(nsts(l-1,k).EQ.-1)nsts(l,k)=1
               ENDIF
               IF(l+1.LE.nnz)THEN
                  IF(nsts(l+1,k).EQ.-1)nsts(l,k)=1
               ENDIF
               IF(k-1.GE.1)THEN
                  IF(nsts(l,k-1).EQ.-1)nsts(l,k)=1
               ENDIF
               IF(k+1.LE.nnx)THEN
                  IF(nsts(l,k+1).EQ.-1)nsts(l,k)=1
               ENDIF
            ENDIF
         ENDDO
      ENDDO
!
!     Finally, call routine for computing traveltimes once
!     again.
!
      urg=2
      CALL travel(x,z,urg)
   ELSE
!
!     Call a subroutine that works out the first-arrival traveltime
!     field.
!
      CALL travel(x,z,urg)
   ENDIF
!
!  Find source-receiver traveltimes if required
!
   IF(fsrt.eq.1)THEN
      CALL srtimes(x,z,i)
   ENDIF
!
!  Calculate raypath geometries and write to file if required.
!  Calculate Frechet derivatives with the same subroutine
!  if required.
!
   IF(wrgf.eq.i.OR.wrgf.LT.0.OR.cfd.EQ.1)THEN
      CALL rpaths(wrgf,i,cfd,x,z)
   ENDIF
!
!  If required, write traveltime field to file
!
   IF(wttf.eq.i)THEN
      !OPEN(UNIT=30,FILE=travelt,FORM='unformatted',STATUS='unknown')
      OPEN(UNIT=30,FILE=travelt,STATUS='unknown')
      WRITE(30,*)goxd,gozd
      WRITE(30,*)nnx,nnz
      WRITE(30,*)dnxd,dnzd
      DO j=1,nnz
         DO k=1,nnx
            WRITE(30,*)ttn(j,k)
         ENDDO
      ENDDO
      CLOSE(30)
   ENDIF
   IF(asgr.EQ.1)DEALLOCATE(ttnr,nstsr)
ENDDO
!
! Close rtravel if required
!
IF(fsrt.eq.1)THEN
   CLOSE(10)
ENDIF
IF(cfd.EQ.1)THEN
   CLOSE(50)
ENDIF
IF(wrgf.NE.0)THEN
!
!  Notify about ray-boundary intersections if required.
!
   IF(rbint.EQ.1)THEN
      WRITE(6,*)'Note that at least one two-point ray path'
      WRITE(6,*)'tracked along the boundary of the model.'
      WRITE(6,*)'This class of path is unlikely to be'
      WRITE(6,*)'a true path, and it is STRONGLY RECOMMENDED'
      WRITE(6,*)'that you adjust the dimensions of your grid'
      WRITE(6,*)'to prevent this from occurring.'
   ENDIF
   CLOSE(40)
ENDIF
IF(asgr.EQ.1)THEN
   DEALLOCATE (velnb, STAT=checkstat)
   IF(checkstat > 0)THEN
      WRITE(6,*)'Error with DEALLOCATE: PROGRAM fmmin2d: velnb'
   ENDIF
ENDIF
IF(fsrt.eq.1)THEN
   DEALLOCATE (rcx,rcz, STAT=checkstat)
   IF(checkstat > 0)THEN
      WRITE(6,*)'Error with DEALLOCATE: PROGRAM fmmin2d: rcx,rcz'
   ENDIF
ENDIF
DEALLOCATE (veln,ttn,scx,scz,nsts,btg,srs, STAT=checkstat)
IF(checkstat > 0)THEN
   WRITE(6,*)'Error with DEALLOCATE: PROGRAM fmmin2d: final deallocate'
ENDIF
WRITE(6,*)'Program fm2dss has finished successfully!'
STOP
END PROGRAM fmmin2d

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! TYPE: SUBROUTINE
! CODE: FORTRAN 90
! This subroutine is passed the name of the velocity
! grid file (grid) and reads in the velocity vertex values.
! The gridded values are globally shared via
! a MODULE statement. The values of the global propagation
! grid are also computed here.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE gridder(grid)
USE globalp
IMPLICIT NONE
INTEGER :: i,j,l,m,i1,j1,conx,conz,stx,stz
REAL(KIND=i10) :: u,sumi,sumj
REAL(KIND=i10), DIMENSION(:,:), ALLOCATABLE :: ui,vi
CHARACTER (LEN=30) :: grid
!
! u = independent parameter for b-spline
! ui,vi = bspline basis functions
! conx,conz = variables for edge of B-spline grid
! stx,stz = counters for veln grid points
! sumi,sumj = summation variables for computing b-spline
!
! Open the grid file and read in the velocity grid.
!
OPEN(UNIT=10,FILE=grid,STATUS='old')
READ(10,*)nvx,nvz
READ(10,*)goxd,gozd
READ(10,*)dvxd,dvzd
ALLOCATE(velv(0:nvz+1,0:nvx+1), STAT=checkstat)
IF(checkstat > 0)THEN
   WRITE(6,*)'Error with ALLOCATE: SUBROUTINE gridder: REAL velv'
ENDIF
DO i=0,nvz+1
   DO j=0,nvx+1
      READ(10,*)velv(i,j)
   ENDDO
ENDDO
CLOSE(10)
!
! Convert from degrees to radians
!
dvx=dvxd*pi/180.0
dvz=dvzd*pi/180.0
gox=(90.0-goxd)*pi/180.0
goz=gozd*pi/180.0
!
! Compute corresponding values for propagation grid.
!
nnx=(nvx-1)*gdx+1
nnz=(nvz-1)*gdz+1
dnx=dvx/gdx
dnz=dvz/gdz
dnxd=dvxd/gdx
dnzd=dvzd/gdz
ALLOCATE(veln(nnz,nnx), STAT=checkstat)
IF(checkstat > 0)THEN
   WRITE(6,*)'Error with ALLOCATE: SUBROUTINE gridder: REAL veln'
ENDIF
!
! Now dice up the grid
!
ALLOCATE(ui(gdx+1,4), STAT=checkstat)
IF(checkstat > 0)THEN
   WRITE(6,*)'Error with ALLOCATE: Subroutine gridder: REAL ui'
ENDIF
DO i=1,gdx+1
   u=gdx
   u=(i-1)/u
   ui(i,1)=(1.0-u)**3/6.0
   ui(i,2)=(4.0-6.0*u**2+3.0*u**3)/6.0
   ui(i,3)=(1.0+3.0*u+3.0*u**2-3.0*u**3)/6.0
   ui(i,4)=u**3/6.0
ENDDO
ALLOCATE(vi(gdz+1,4), STAT=checkstat)
IF(checkstat > 0)THEN
   WRITE(6,*)'Error with ALLOCATE: Subroutine gridder: REAL vi'
ENDIF
DO i=1,gdz+1
   u=gdz
   u=(i-1)/u
   vi(i,1)=(1.0-u)**3/6.0
   vi(i,2)=(4.0-6.0*u**2+3.0*u**3)/6.0
   vi(i,3)=(1.0+3.0*u+3.0*u**2-3.0*u**3)/6.0
   vi(i,4)=u**3/6.0
ENDDO
DO i=1,nvz-1
   conz=gdz
   IF(i==nvz-1)conz=gdz+1
   DO j=1,nvx-1
      conx=gdx
      IF(j==nvx-1)conx=gdx+1
      DO l=1,conz
         stz=gdz*(i-1)+l
         DO m=1,conx
            stx=gdx*(j-1)+m
            sumi=0.0
            DO i1=1,4
               sumj=0.0
               DO j1=1,4
                  sumj=sumj+ui(m,j1)*velv(i-2+i1,j-2+j1)
               ENDDO
               sumi=sumi+vi(l,i1)*sumj
            ENDDO
            veln(stz,stx)=sumi
         ENDDO
      ENDDO
   ENDDO
ENDDO
DEALLOCATE(ui,vi, STAT=checkstat)
IF(checkstat > 0)THEN
   WRITE(6,*)'Error with DEALLOCATE: SUBROUTINE gridder: REAL ui,vi'
ENDIF
END SUBROUTINE gridder

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! TYPE: SUBROUTINE
! CODE: FORTRAN 90
! This subroutine is similar to bsplreg except that it has been
! modified to deal with source grid refinement
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE bsplrefine
USE globalp
INTEGER :: i,j,k,l,i1,j1,st1,st2,nrzr,nrxr
INTEGER :: origx,origz,conx,conz,idm1,idm2
REAL(KIND=i10) :: u,v
REAL(KIND=i10), DIMENSION (4) :: sum
REAL(KIND=i10), DIMENSION(gdx*sgdl+1,gdz*sgdl+1,4) :: ui,vi
!
! nrxr,nrzr = grid refinement level for source grid in x,z
! origx,origz = local origin of refined source grid
!
! Begin by calculating the values of the basis functions
!
nrxr=gdx*sgdl
nrzr=gdz*sgdl
DO i=1,nrzr+1
   v=nrzr
   v=(i-1)/v
   DO j=1,nrxr+1
      u=nrxr
      u=(j-1)/u
      ui(j,i,1)=(1.0-u)**3/6.0
      ui(j,i,2)=(4.0-6.0*u**2+3.0*u**3)/6.0
      ui(j,i,3)=(1.0+3.0*u+3.0*u**2-3.0*u**3)/6.0
      ui(j,i,4)=u**3/6.0
      vi(j,i,1)=(1.0-v)**3/6.0
      vi(j,i,2)=(4.0-6.0*v**2+3.0*v**3)/6.0
      vi(j,i,3)=(1.0+3.0*v+3.0*v**2-3.0*v**3)/6.0
      vi(j,i,4)=v**3/6.0
   ENDDO
ENDDO
!
! Calculate the velocity values.
!
origx=(vnl-1)*sgdl+1
origz=(vnt-1)*sgdl+1
DO i=1,nvz-1
   conz=nrzr
   IF(i==nvz-1)conz=nrzr+1
   DO j=1,nvx-1
      conx=nrxr
      IF(j==nvx-1)conx=nrxr+1
      DO k=1,conz
         st1=gdz*(i-1)+(k-1)/sgdl+1
         IF(st1.LT.vnt.OR.st1.GT.vnb)CYCLE
         st1=nrzr*(i-1)+k
         DO l=1,conx
            st2=gdx*(j-1)+(l-1)/sgdl+1
            IF(st2.LT.vnl.OR.st2.GT.vnr)CYCLE
            st2=nrxr*(j-1)+l
            DO i1=1,4
               sum(i1)=0.0
               DO j1=1,4
                  sum(i1)=sum(i1)+ui(l,k,j1)*velv(i-2+i1,j-2+j1)
               ENDDO
               sum(i1)=vi(l,k,i1)*sum(i1)
            ENDDO
            idm1=st1-origz+1
            idm2=st2-origx+1
            IF(idm1.LT.1.OR.idm1.GT.nnz)CYCLE
            IF(idm2.LT.1.OR.idm2.GT.nnx)CYCLE
            veln(idm1,idm2)=sum(1)+sum(2)+sum(3)+sum(4)
         ENDDO
      ENDDO
   ENDDO
ENDDO
END SUBROUTINE bsplrefine

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! TYPE: SUBROUTINE
! CODE: FORTRAN 90
! This subroutine calculates all receiver traveltimes for
! a given source and writes the results to file.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE srtimes(scx,scz,csid)
USE globalp
IMPLICIT NONE
INTEGER :: i,k,l,irx,irz,sw,isx,isz,csid
INTEGER, PARAMETER :: noray=0,yesray=1
INTEGER, PARAMETER :: i5=SELECTED_REAL_KIND(5,10)
REAL(KIND=i5) :: trr
REAL(KIND=i5), PARAMETER :: norayt=0.0
REAL(KIND=i10) :: drx,drz,produ,scx,scz
REAL(KIND=i10) :: sred,dpl,rd1,vels,velr
REAL(KIND=i10), DIMENSION (2,2) :: vss
!
! irx,irz = Coordinates of cell containing receiver
! trr = traveltime value at receiver
! produ = dummy multiplier
! drx,drz = receiver distance from (i,j,k) grid node
! scx,scz = source coordinates
! isx,isz = source cell location
! sred = Distance from source to receiver
! dpl = Minimum path length in source neighbourhood.
! vels,velr = velocity at source and receiver
! vss = velocity at four grid points about source or receiver.
! csid = current source ID
! noray = switch to indicate no ray present
! norayt = default value given to null ray
! yesray = switch to indicate that ray is present
!
! Determine source-receiver traveltimes one at a time.
!
DO i=1,nrc
   IF(srs(i,csid).EQ.0)THEN
      WRITE(10,*)noray,norayt
      CYCLE
   ENDIF
! 
!  The first step is to locate the receiver in the grid.
!
   irx=INT((rcx(i)-gox)/dnx)+1
   irz=INT((rcz(i)-goz)/dnz)+1
   sw=0
   IF(irx.lt.1.or.irx.gt.nnx)sw=1
   IF(irz.lt.1.or.irz.gt.nnz)sw=1
   IF(sw.eq.1)then
      irx=90.0-irx*180.0/pi
      irz=irz*180.0/pi
      WRITE(6,*)"Receiver lies outside model (lat,long)= ",irx,irz
      WRITE(6,*)"TERMINATING PROGRAM!!!!"
      STOP
   ENDIF
   IF(irx.eq.nnx)irx=irx-1
   IF(irz.eq.nnz)irz=irz-1
!
!  Location of receiver successfully found within the grid. Now approximate
!  traveltime at receiver using bilinear interpolation from four
!  surrounding grid points. Note that bilinear interpolation is a poor
!  approximation when traveltime gradient varies significantly across a cell,
!  particularly near the source. Thus, we use an improved approximation in this
!  case. First, locate current source cell.
!
   isx=INT((scx-gox)/dnx)+1
   isz=INT((scz-goz)/dnz)+1
   dpl=dnx*earth
   rd1=dnz*earth*SIN(gox)
   IF(rd1.LT.dpl)dpl=rd1
   rd1=dnz*earth*SIN(gox+(nnx-1)*dnx)
   IF(rd1.LT.dpl)dpl=rd1
   sred=((scx-rcx(i))*earth)**2
   sred=sred+((scz-rcz(i))*earth*SIN(rcx(i)))**2
   sred=SQRT(sred)
   IF(sred.LT.dpl)sw=1
   IF(isx.EQ.irx)THEN
      IF(isz.EQ.irz)sw=1
   ENDIF
   IF(sw.EQ.1)THEN
!
!     Compute velocity at source and receiver
!
      DO k=1,2
         DO l=1,2
            vss(k,l)=veln(isz-1+l,isx-1+k)
         ENDDO
      ENDDO
      drx=(scx-gox)-(isx-1)*dnx
      drz=(scz-goz)-(isz-1)*dnz
      CALL bilinear(vss,drx,drz,vels)
      DO k=1,2
         DO l=1,2
            vss(k,l)=veln(irz-1+l,irx-1+k)
         ENDDO
      ENDDO
      drx=(rcx(i)-gox)-(irx-1)*dnx
      drz=(rcz(i)-goz)-(irz-1)*dnz
      CALL bilinear(vss,drx,drz,velr)
      trr=2.0*sred/(vels+velr)
   ELSE
      drx=(rcx(i)-gox)-(irx-1)*dnx
      drz=(rcz(i)-goz)-(irz-1)*dnz
      trr=0.0
      DO k=1,2
         DO l=1,2
            produ=(1.0-ABS(((l-1)*dnz-drz)/dnz))*(1.0-ABS(((k-1)*dnx-drx)/dnx))
            trr=trr+ttn(irz-1+l,irx-1+k)*produ
         ENDDO
      ENDDO
   ENDIF
   WRITE(10,*)yesray,trr
ENDDO
END SUBROUTINE srtimes

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! TYPE: SUBROUTINE
! CODE: FORTRAN 90
! This subroutine calculates ray path geometries for each
! source-receiver combination. It will also compute
! Frechet derivatives using these ray paths if required.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE rpaths(wrgf,csid,cfd,scx,scz)
USE globalp
IMPLICIT NONE
INTEGER, PARAMETER :: i5=SELECTED_REAL_KIND(5,10)
INTEGER, PARAMETER :: nopath=0
INTEGER :: i,j,k,l,m,n,ipx,ipz,ipxr,ipzr,nrp,sw
INTEGER :: wrgf,cfd,csid,ipxo,ipzo,isx,isz
INTEGER :: ivx,ivz,ivxo,ivzo,nhp,maxrp
INTEGER :: ivxt,ivzt,ipxt,ipzt,isum,igref
INTEGER, DIMENSION (4) :: chp
REAL(KIND=i5), PARAMETER :: ftol=1.0e-6
REAL(KIND=i5) :: rayx,rayz
REAL(KIND=i10) :: dpl,rd1,rd2,xi,zi,vel,velo
REAL(KIND=i10) :: v,w,rigz,rigx,dinc,scx,scz
REAL(KIND=i10) :: dtx,dtz,drx,drz,produ,sred
REAL(KIND=i10), DIMENSION (:), ALLOCATABLE :: rgx,rgz
REAL(KIND=i5), DIMENSION (:,:), ALLOCATABLE :: fdm
REAL(KIND=i10), DIMENSION (4) :: vrat,vi,wi,vio,wio
!
! ipx,ipz = Coordinates of cell containing current point
! ipxr,ipzr = Same as ipx,apz except for refined grid
! ipxo,ipzo = Coordinates of previous point
! rgx,rgz = (x,z) coordinates of ray geometry
! ivx,ivz = Coordinates of B-spline vertex containing current point
! ivxo,ivzo = Coordinates of previous point
! maxrp = maximum number of ray points
! nrp = number of points to describe ray
! dpl = incremental path length of ray
! xi,zi = edge of model coordinates
! dtx,dtz = components of gradT
! wrgf = Write out raypaths? (<0=all,0=no,>0=souce id)
! cfd = calculate Frechet derivatives? (0=no,1=yes)
! csid = current source id
! fdm = Frechet derivative matrix
! nhp = Number of ray segment-B-spline cell hit points
! vrat = length ratio of ray sub-segment
! chp = pointer to incremental change in x or z cell
! drx,drz = distance from reference node of cell
! produ = variable for trilinear interpolation
! vel = velocity at current point
! velo = velocity at previous point
! v,w = local variables of x,z
! vi,wi = B-spline basis functions at current point
! vio,wio = vi,wi for previous point
! ivxt,ivzt = temporary ivr,ivx,ivz values
! rigx,rigz = end point of sub-segment of ray path
! ipxt,ipzt = temporary ipx,ipz values
! dinc = path length of ray sub-segment
! rayr,rayx,rayz = ray path coordinates in single precision
! isx,isz = current source cell location
! scx,scz = current source coordinates
! sred = source to ray endpoint distance
! igref = ray endpoint lies in refined grid? (0=no,1=yes)
! nopath = switch to indicate that no path is present
!
! Allocate memory to arrays for storing ray path geometry
!
maxrp=nnx*nnz
ALLOCATE(rgx(maxrp+1), STAT=checkstat)
IF(checkstat > 0)THEN
   WRITE(6,*)'Error with ALLOCATE: SUBROUTINE rpaths: REAL rgx'
ENDIF
ALLOCATE(rgz(maxrp+1), STAT=checkstat)
IF(checkstat > 0)THEN
   WRITE(6,*)'Error with ALLOCATE: SUBROUTINE rpaths: REAL rgz'
ENDIF
!
! Allocate memory to partial derivative array
!
IF(cfd.EQ.1)THEN
   ALLOCATE(fdm(0:nvz+1,0:nvx+1), STAT=checkstat)
   IF(checkstat > 0)THEN
      WRITE(6,*)'Error with ALLOCATE: SUBROUTINE rpaths: REAL fdm'
   ENDIF
ENDIF
!
! Locate current source cell
!
IF(asgr.EQ.1)THEN
   isx=INT((scx-goxr)/dnxr)+1
   isz=INT((scz-gozr)/dnzr)+1
ELSE
   isx=INT((scx-gox)/dnx)+1
   isz=INT((scz-goz)/dnz)+1
ENDIF
!
! Set ray incremental path length equal to half width
! of cell
!
  dpl=dnx*earth
  rd1=dnz*earth*SIN(gox)
  IF(rd1.LT.dpl)dpl=rd1
  rd1=dnz*earth*SIN(gox+(nnx-1)*dnx)
  IF(rd1.LT.dpl)dpl=rd1
  dpl=0.5*dpl
!
! Loop through all the receivers
!
DO i=1,nrc
!
!  If path does not exist, then cycle the loop
!
   IF(cfd.EQ.1)THEN
      fdm=0.0
   ENDIF
   IF(srs(i,csid).EQ.0)THEN
      IF(wrgf.EQ.csid.OR.wrgf.LT.0)THEN
         WRITE(40,*)nopath
      ENDIF
      IF(cfd.EQ.1)THEN
         WRITE(50,*)nopath
      ENDIF
      CYCLE
   ENDIF
!
!  The first step is to locate the receiver in the grid.
!
   ipx=INT((rcx(i)-gox)/dnx)+1
   ipz=INT((rcz(i)-goz)/dnz)+1
   sw=0
   IF(ipx.lt.1.or.ipx.gt.nnx)sw=1
   IF(ipz.lt.1.or.ipz.gt.nnz)sw=1
   !IF(ipx.lt.1.or.ipx.ge.nnx)sw=1 ! MS change to allow receiver on boundary
   !IF(ipz.lt.1.or.ipz.ge.nnz)sw=1 ! MS change to allow receiver on boundary
   IF(sw.eq.1)then
      ipx=90.0-ipx*180.0/pi
      ipz=ipz*180.0/pi
      WRITE(6,*)"Receiver lies outside model (lat,long)= ",ipx,ipz
      WRITE(6,*)"TERMINATING PROGRAM!!!"
      STOP
   ENDIF
   IF(ipx.eq.nnx)ipx=ipx-1
   IF(ipz.eq.nnz)ipz=ipz-1
!
!  First point of the ray path is the receiver
!
   rgx(1)=rcx(i)
   rgz(1)=rcz(i)
!
!  Test to see if receiver is in source neighbourhood
!
   sred=((scx-rgx(1))*earth)**2
   sred=sred+((scz-rgz(1))*earth*SIN(rgx(1)))**2
   sred=SQRT(sred)
   IF(sred.LT.2.0*dpl)THEN
      rgx(2)=scx
      rgz(2)=scz
      nrp=2
      sw=1
   ENDIF
!
!  If required, see if receiver lies within refined grid
!
   IF(asgr.EQ.1)THEN
      ipxr=INT((rcx(i)-goxr)/dnxr)+1
      ipzr=INT((rcz(i)-gozr)/dnzr)+1
      igref=1
      IF(ipxr.LT.1.OR.ipxr.GE.nnxr)igref=0
      IF(ipzr.LT.1.OR.ipzr.GE.nnzr)igref=0
      IF(igref.EQ.1)THEN
         IF(nstsr(ipzr,ipxr).NE.0.OR.nstsr(ipzr+1,ipxr).NE.0)igref=0
         IF(nstsr(ipzr,ipxr+1).NE.0.OR.nstsr(ipzr+1,ipxr+1).NE.0)igref=0
      ENDIF
   ELSE
      igref=0
   ENDIF
!
!  Due to the method for calculating traveltime gradient, if the
!  the ray end point lies in the source cell, then we are also done.
!
   IF(sw.EQ.0)THEN
      IF(asgr.EQ.1)THEN
         IF(igref.EQ.1)THEN
            IF(ipxr.EQ.isx)THEN
               IF(ipzr.EQ.isz)THEN
                  rgx(2)=scx
                  rgz(2)=scz
                  nrp=2
                  sw=1
               ENDIF
            ENDIF
         ENDIF
      ELSE
         IF(ipx.EQ.isx)THEN
            IF(ipz.EQ.isz)THEN
               rgx(2)=scx
               rgz(2)=scz
               nrp=2
               sw=1
            ENDIF
         ENDIF
      ENDIF
   ENDIF
!
!  Now trace ray from receiver to "source"
!
   DO j=1,maxrp
      IF(sw.EQ.1)EXIT
!
!     Calculate traveltime gradient vector for current cell using
!     a first-order or second-order scheme.
!
      IF(igref.EQ.1)THEN
!
!        In this case, we are in the refined grid.
!
!        First order scheme applied here.
!
         dtx=ttnr(ipzr,ipxr+1)-ttnr(ipzr,ipxr)
         dtx=dtx+ttnr(ipzr+1,ipxr+1)-ttnr(ipzr+1,ipxr)
         dtx=dtx/(2.0*earth*dnxr)
         dtz=ttnr(ipzr+1,ipxr)-ttnr(ipzr,ipxr)
         dtz=dtz+ttnr(ipzr+1,ipxr+1)-ttnr(ipzr,ipxr+1)
         dtz=dtz/(2.0*earth*SIN(rgx(j))*dnzr)
      ELSE
!
!        Here, we are in the coarse grid.
!
!        First order scheme applied here.
!
         dtx=ttn(ipz,ipx+1)-ttn(ipz,ipx)
         dtx=dtx+ttn(ipz+1,ipx+1)-ttn(ipz+1,ipx)
         dtx=dtx/(2.0*earth*dnx)
         dtz=ttn(ipz+1,ipx)-ttn(ipz,ipx)
         dtz=dtz+ttn(ipz+1,ipx+1)-ttn(ipz,ipx+1)
         dtz=dtz/(2.0*earth*SIN(rgx(j))*dnz)
      ENDIF
!
!     Calculate the next ray path point
!
      rd1=SQRT(dtx**2+dtz**2)
      rgx(j+1)=rgx(j)-dpl*dtx/(earth*rd1)
      rgz(j+1)=rgz(j)-dpl*dtz/(earth*SIN(rgx(j))*rd1)
!
!     Determine which cell the new ray endpoint
!     lies in.
!
      ipxo=ipx
      ipzo=ipz
      IF(asgr.EQ.1)THEN
!
!        Here, we test to see whether the ray endpoint lies
!        within a cell of the refined grid
!
         ipxr=INT((rgx(j+1)-goxr)/dnxr)+1
         ipzr=INT((rgz(j+1)-gozr)/dnzr)+1
         igref=1
         IF(ipxr.LT.1.OR.ipxr.GE.nnxr)igref=0
         IF(ipzr.LT.1.OR.ipzr.GE.nnzr)igref=0
         IF(igref.EQ.1)THEN
            IF(nstsr(ipzr,ipxr).NE.0.OR.nstsr(ipzr+1,ipxr).NE.0)igref=0
            IF(nstsr(ipzr,ipxr+1).NE.0.OR.nstsr(ipzr+1,ipxr+1).NE.0)igref=0
         ENDIF
         ipx=INT((rgx(j+1)-gox)/dnx)+1
         ipz=INT((rgz(j+1)-goz)/dnz)+1
      ELSE
         ipx=INT((rgx(j+1)-gox)/dnx)+1
         ipz=INT((rgz(j+1)-goz)/dnz)+1
         igref=0
      ENDIF
!
!     Test the proximity of the source to the ray end point.
!     If it is less than dpl then we are done
!
      sred=((scx-rgx(j+1))*earth)**2
      sred=sred+((scz-rgz(j+1))*earth*SIN(rgx(j+1)))**2
      sred=SQRT(sred)
      sw=0
      IF(sred.LT.2.0*dpl)THEN
         rgx(j+2)=scx
         rgz(j+2)=scz
         nrp=j+2
         sw=1
         IF(cfd.NE.1)EXIT
      ENDIF
!
!     Due to the method for calculating traveltime gradient, if the
!     the ray end point lies in the source cell, then we are also done.
!
      IF(sw.EQ.0)THEN
         IF(asgr.EQ.1)THEN
            IF(igref.EQ.1)THEN
               IF(ipxr.EQ.isx)THEN
                  IF(ipzr.EQ.isz)THEN
                     rgx(j+2)=scx
                     rgz(j+2)=scz
                     nrp=j+2
                     sw=1
                     IF(cfd.NE.1)EXIT
                  ENDIF
               ENDIF
            ENDIF
         ELSE
            IF(ipx.EQ.isx)THEN
               IF(ipz.EQ.isz)THEN
                  rgx(j+2)=scx
                  rgz(j+2)=scz
                  nrp=j+2
                  sw=1
                  IF(cfd.NE.1)EXIT
               ENDIF
            ENDIF
         ENDIF
      ENDIF
!
!     Test whether ray path segment extends beyond
!     box boundaries
!
      IF(ipx.LT.1)THEN
         rgx(j+1)=gox
         ipx=1
         rbint=1
      ENDIF
      IF(ipx.GE.nnx)THEN
         rgx(j+1)=gox+(nnx-1)*dnx
         ipx=nnx-1
         rbint=1
      ENDIF
      IF(ipz.LT.1)THEN
         rgz(j+1)=goz
         ipz=1
         rbint=1
      ENDIF
      IF(ipz.GE.nnz)THEN
         rgz(j+1)=goz+(nnz-1)*dnz
         ipz=nnz-1
         rbint=1
      ENDIF
!
!     Calculate the Frechet derivatives if required.
!
      IF(cfd.EQ.1)THEN
!
!        First determine which B-spline cell the refined cells
!        containing the ray path segment lies in. If they lie
!        in more than one, then we need to divide the problem
!        into separate parts (up to three).
!
         ivx=INT((ipx-1)/gdx)+1
         ivz=INT((ipz-1)/gdz)+1
         ivxo=INT((ipxo-1)/gdx)+1
         ivzo=INT((ipzo-1)/gdz)+1
!
!        Calculate up to two hit points between straight
!        ray segment and cell faces.
!
         nhp=0
         IF(ivx.NE.ivxo)THEN
            nhp=nhp+1
            IF(ivx.GT.ivxo)THEN
               xi=gox+(ivx-1)*dvx
            ELSE
               xi=gox+ivx*dvx
            ENDIF
            vrat(nhp)=(xi-rgx(j))/(rgx(j+1)-rgx(j))
            chp(nhp)=1
         ENDIF
         IF(ivz.NE.ivzo)THEN
            nhp=nhp+1
            IF(ivz.GT.ivzo)THEN
               zi=goz+(ivz-1)*dvz
            ELSE
               zi=goz+ivz*dvz
            ENDIF
            rd1=(zi-rgz(j))/(rgz(j+1)-rgz(j))
            IF(nhp.EQ.1)THEN
               vrat(nhp)=rd1
               chp(nhp)=2
            ELSE
               IF(rd1.GE.vrat(nhp-1))THEN
                  vrat(nhp)=rd1
                  chp(nhp)=2
               ELSE
                  vrat(nhp)=vrat(nhp-1)
                  chp(nhp)=chp(nhp-1)
                  vrat(nhp-1)=rd1
                  chp(nhp-1)=2
               ENDIF
            ENDIF
         ENDIF
         nhp=nhp+1
         vrat(nhp)=1.0
         chp(nhp)=0
!
!        Calculate the velocity, v and w values of the
!        first point
!
         drx=(rgx(j)-gox)-(ipxo-1)*dnx
         drz=(rgz(j)-goz)-(ipzo-1)*dnz
         vel=0.0
         DO l=1,2
            DO m=1,2
               produ=(1.0-ABS(((m-1)*dnz-drz)/dnz))
               produ=produ*(1.0-ABS(((l-1)*dnx-drx)/dnx))
               IF(ipzo-1+m.LE.nnz.AND.ipxo-1+l.LE.nnx)THEN
                  vel=vel+veln(ipzo-1+m,ipxo-1+l)*produ
               ENDIF
            ENDDO
         ENDDO
         drx=(rgx(j)-gox)-(ivxo-1)*dvx
         drz=(rgz(j)-goz)-(ivzo-1)*dvz
         v=drx/dvx
         w=drz/dvz
!
!        Calculate the 12 basis values at the point
!
         vi(1)=(1.0-v)**3/6.0
         vi(2)=(4.0-6.0*v**2+3.0*v**3)/6.0
         vi(3)=(1.0+3.0*v+3.0*v**2-3.0*v**3)/6.0
         vi(4)=v**3/6.0
         wi(1)=(1.0-w)**3/6.0
         wi(2)=(4.0-6.0*w**2+3.0*w**3)/6.0
         wi(3)=(1.0+3.0*w+3.0*w**2-3.0*w**3)/6.0
         wi(4)=w**3/6.0
         ivxt=ivxo
         ivzt=ivzo
!
!        Now loop through the one or more sub-segments of the
!        ray path segment and calculate partial derivatives
!
         DO k=1,nhp
            velo=vel
            vio=vi
            wio=wi
            IF(k.GT.1)THEN
               IF(chp(k-1).EQ.1)THEN
                  ivxt=ivx
               ELSE IF(chp(k-1).EQ.2)THEN
                  ivzt=ivz
               ENDIF
            ENDIF
!
!           Calculate the velocity, v and w values of the
!           new point
!
            rigz=rgz(j)+vrat(k)*(rgz(j+1)-rgz(j))
            rigx=rgx(j)+vrat(k)*(rgx(j+1)-rgx(j))
            ipxt=INT((rigx-gox)/dnx)+1
            ipzt=INT((rigz-goz)/dnz)+1
            drx=(rigx-gox)-(ipxt-1)*dnx
            drz=(rigz-goz)-(ipzt-1)*dnz
            vel=0.0
            DO m=1,2
               DO n=1,2
                  produ=(1.0-ABS(((n-1)*dnz-drz)/dnz))
                  produ=produ*(1.0-ABS(((m-1)*dnx-drx)/dnx))
                  IF(ipzt-1+n.LE.nnz.AND.ipxt-1+m.LE.nnx)THEN
                     vel=vel+veln(ipzt-1+n,ipxt-1+m)*produ
                  ENDIF
               ENDDO
            ENDDO
            drx=(rigx-gox)-(ivxt-1)*dvx
            drz=(rigz-goz)-(ivzt-1)*dvz
            v=drx/dvx
            w=drz/dvz
!
!           Calculate the 8 basis values at the new point
!
            vi(1)=(1.0-v)**3/6.0
            vi(2)=(4.0-6.0*v**2+3.0*v**3)/6.0
            vi(3)=(1.0+3.0*v+3.0*v**2-3.0*v**3)/6.0
            vi(4)=v**3/6.0
            wi(1)=(1.0-w)**3/6.0
            wi(2)=(4.0-6.0*w**2+3.0*w**3)/6.0
            wi(3)=(1.0+3.0*w+3.0*w**2-3.0*w**3)/6.0
            wi(4)=w**3/6.0
!
!           Calculate the incremental path length
!
            IF(k.EQ.1)THEN
               dinc=vrat(k)*dpl
            ELSE
               dinc=(vrat(k)-vrat(k-1))*dpl
            ENDIF
!
!           Now compute the 16 contributions to the partial
!           derivatives.
!
            DO l=1,4
               DO m=1,4
                  rd1=vi(m)*wi(l)/vel**2
                  rd2=vio(m)*wio(l)/velo**2
                  rd1=-(rd1+rd2)*dinc/2.0
                  rd2=fdm(ivzt-2+l,ivxt-2+m)
                  fdm(ivzt-2+l,ivxt-2+m)=rd1+rd2
               ENDDO
            ENDDO
         ENDDO
      ENDIF
      IF(j.EQ.maxrp.AND.sw.EQ.0)THEN
         WRITE(6,*)'Error with ray path detected!!!'
         WRITE(6,*)'Source id: ',csid
         WRITE(6,*)'Receiver id: ',i
      ENDIF
   ENDDO
!
!  Write ray paths to output file
!
   IF(wrgf.EQ.csid.OR.wrgf.LT.0)THEN
      WRITE(40,*)nrp
      DO j=1,nrp
         rayx=(pi/2-rgx(j))*180.0/pi
         rayz=rgz(j)*180.0/pi
         WRITE(40,*)rayx,rayz
      ENDDO
   ENDIF
!
!  Write partial derivatives to output file
!
   IF(cfd.EQ.1)THEN
!
!     Determine the number of non-zero elements.
!
      isum=0
      DO j=0,nvz+1
         DO k=0,nvx+1
            IF(ABS(fdm(j,k)).GE.ftol)isum=isum+1
         ENDDO
      ENDDO
      WRITE(50,*)isum
      isum=0
      DO j=0,nvz+1
         DO k=0,nvx+1
            isum=isum+1
            IF(ABS(fdm(j,k)).GE.ftol)WRITE(50,*)isum,fdm(j,k)
         ENDDO
      ENDDO
   ENDIF
ENDDO
IF(cfd.EQ.1)THEN
   DEALLOCATE(fdm, STAT=checkstat)
   IF(checkstat > 0)THEN
      WRITE(6,*)'Error with DEALLOCATE: SUBROUTINE rpaths: fdm'
   ENDIF
ENDIF
DEALLOCATE(rgx,rgz, STAT=checkstat)
IF(checkstat > 0)THEN
   WRITE(6,*)'Error with DEALLOCATE: SUBROUTINE rpaths: rgx,rgz'
ENDIF
END SUBROUTINE rpaths

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! TYPE: SUBROUTINE
! CODE: FORTRAN 90
! This subroutine is passed four node values which lie on
! the corners of a rectangle and the coordinates of a point
! lying within the rectangle. It calculates the value at
! the internal point by using bilinear interpolation.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE bilinear(nv,dsx,dsz,biv)
USE globalp
IMPLICIT NONE
INTEGER :: i,j
REAL(KIND=i10) :: dsx,dsz,biv
REAL(KIND=i10), DIMENSION(2,2) :: nv
REAL(KIND=i10) :: produ
!
! nv = four node vertex values
! dsx,dsz = distance between internal point and top left node
! dnx,dnz = width and height of node rectangle
! biv = value at internal point calculated by bilinear interpolation
! produ = product variable
!
biv=0.0
DO i=1,2
   DO j=1,2
      produ=(1.0-ABS(((i-1)*dnx-dsx)/dnx))*(1.0-ABS(((j-1)*dnz-dsz)/dnz))
      biv=biv+nv(i,j)*produ
   ENDDO
ENDDO
END SUBROUTINE bilinear

      SUBROUTINE dsvdcmp(a,m,n,mp,np,w,v)
      INTEGER m,mp,n,np,NMAX
      DOUBLE PRECISION a(mp,np),v(np,np),w(np)
      PARAMETER (NMAX=900)
CU    USES dpythag
      INTEGER i,its,j,jj,k,l,nm
      DOUBLE PRECISION anorm,c,f,g,h,s,scale,x,y,z,rv1(NMAX),dpythag
      g=0.0d0
      scale=0.0d0
      anorm=0.0d0
      do 25 i=1,n
        l=i+1
        rv1(i)=scale*g
        g=0.0d0
        s=0.0d0
        scale=0.0d0
        if(i.le.m)then
          do 11 k=i,m
            scale=scale+abs(a(k,i))
11        continue
          if(scale.ne.0.0d0)then
            do 12 k=i,m
              a(k,i)=a(k,i)/scale
              s=s+a(k,i)*a(k,i)
12          continue
            f=a(i,i)
            g=-sign(sqrt(s),f)
            h=f*g-s
            a(i,i)=f-g
            do 15 j=l,n
              s=0.0d0
              do 13 k=i,m
                s=s+a(k,i)*a(k,j)
13            continue
              f=s/h
              do 14 k=i,m
                a(k,j)=a(k,j)+f*a(k,i)
14            continue
15          continue
            do 16 k=i,m
              a(k,i)=scale*a(k,i)
16          continue
          endif
        endif
        w(i)=scale *g
        g=0.0d0
        s=0.0d0
        scale=0.0d0
        if((i.le.m).and.(i.ne.n))then
          do 17 k=l,n
            scale=scale+abs(a(i,k))
17        continue
          if(scale.ne.0.0d0)then
            do 18 k=l,n
              a(i,k)=a(i,k)/scale
              s=s+a(i,k)*a(i,k)
18          continue
            f=a(i,l)
            g=-sign(sqrt(s),f)
            h=f*g-s
            a(i,l)=f-g
            do 19 k=l,n
              rv1(k)=a(i,k)/h
19          continue
            do 23 j=l,m
              s=0.0d0
              do 21 k=l,n
                s=s+a(j,k)*a(i,k)
21            continue
              do 22 k=l,n
                a(j,k)=a(j,k)+s*rv1(k)
22            continue
23          continue
            do 24 k=l,n
              a(i,k)=scale*a(i,k)
24          continue
          endif
        endif
        anorm=max(anorm,(abs(w(i))+abs(rv1(i))))
25    continue
      do 32 i=n,1,-1
        if(i.lt.n)then
          if(g.ne.0.0d0)then
            do 26 j=l,n
              v(j,i)=(a(i,j)/a(i,l))/g
26          continue
            do 29 j=l,n
              s=0.0d0
              do 27 k=l,n
                s=s+a(i,k)*v(k,j)
27            continue
              do 28 k=l,n
                v(k,j)=v(k,j)+s*v(k,i)
28            continue
29          continue
          endif
          do 31 j=l,n
            v(i,j)=0.0d0
            v(j,i)=0.0d0
31        continue
        endif
        v(i,i)=1.0d0
        g=rv1(i)
        l=i
32    continue
      do 39 i=min(m,n),1,-1
        l=i+1
        g=w(i)
        do 33 j=l,n
          a(i,j)=0.0d0
33      continue
        if(g.ne.0.0d0)then
          g=1.0d0/g
          do 36 j=l,n
            s=0.0d0
            do 34 k=l,m
              s=s+a(k,i)*a(k,j)
34          continue
            f=(s/a(i,i))*g
            do 35 k=i,m
              a(k,j)=a(k,j)+f*a(k,i)
35          continue
36        continue
          do 37 j=i,m
            a(j,i)=a(j,i)*g
37        continue
        else
          do 38 j= i,m
            a(j,i)=0.0d0
38        continue
        endif
        a(i,i)=a(i,i)+1.0d0
39    continue
      do 49 k=n,1,-1
        do 48 its=1,30
          do 41 l=k,1,-1
            nm=l-1
            if((abs(rv1(l))+anorm).eq.anorm)  goto 2
            if((abs(w(nm))+anorm).eq.anorm)  goto 1
41        continue
1         c=0.0d0
          s=1.0d0
          do 43 i=l,k
            f=s*rv1(i)
            rv1(i)=c*rv1(i)
            if((abs(f)+anorm).eq.anorm) goto 2
            g=w(i)
            h=dpythag(f,g)
            w(i)=h
            h=1.0d0/h
            c= (g*h)
            s=-(f*h)
            do 42 j=1,m
              y=a(j,nm)
              z=a(j,i)
              a(j,nm)=(y*c)+(z*s)
              a(j,i)=-(y*s)+(z*c)
42          continue
43        continue
2         z=w(k)
          if(l.eq.k)then
            if(z.lt.0.0d0)then
              w(k)=-z
              do 44 j=1,n
                v(j,k)=-v(j,k)
44            continue
            endif
            goto 3
          endif
!          if(its.eq.30) pause 'no convergence in svdcmp'
          x=w(l)
          nm=k-1
          y=w(nm)
          g=rv1(nm)
          h=rv1(k)
          f=((y-z)*(y+z)+(g-h)*(g+h))/(2.0d0*h*y)
          g=dpythag(f,1.0d0)
          f=((x-z)*(x+z)+h*((y/(f+sign(g,f)))-h))/x
          c=1.0d0
          s=1.0d0
          do 47 j=l,nm
            i=j+1
            g=rv1(i)
            y=w(i)
            h=s*g
            g=c*g
            z=dpythag(f,h)
            rv1(j)=z
            c=f/z
            s=h/z
            f= (x*c)+(g*s)
            g=-(x*s)+(g*c)
            h=y*s
            y=y*c
            do 45 jj=1,n
              x=v(jj,j)
              z=v(jj,i)
              v(jj,j)= (x*c)+(z*s)
              v(jj,i)=-(x*s)+(z*c)
45          continue
            z=dpythag(f,h)
            w(j)=z
            if(z.ne.0.0d0)then
              z=1.0d0/z
              c=f*z
              s=h*z
            endif
            f= (c*g)+(s*y)
            x=-(s*g)+(c*y)
            do 46 jj=1,m
              y=a(jj,j)
              z=a(jj,i)
              a(jj,j)= (y*c)+(z*s)
              a(jj,i)=-(y*s)+(z*c)
46          continue
47        continue
          rv1(l)=0.0d0
          rv1(k)=f
          w(k)=x
48      continue
3       continue
49    continue
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software '%1&9p#!.

      subroutine qlayer( 
     &     lc, ang, n, h, valpha, vbeta, rho, qa, qb, rs, 
     &     w, up, wp, usv, wsv, vsh )
***********************************************                         
*     crustal response for p and s waves      *                         
*     in layered dissipative medium           *                         
*     codedby T. Kurita & T. Mikumo           *                         
*     revised by T. Shibutani                 *                         
***********************************************                         
c                                                                       
c
        include 'rfi_param.inc'

      parameter     ( nlmx = maxsublayer )
      parameter     ( nb  = maxdata )
      parameter     ( nb2 = nb/2+1 )
c
c
      real w(nb2), h(nlmx), qa(nlmx), qb(nlmx), rs(nlmx), rho(nlmx)
c
      complex alpha(nlmx), ralpha(nlmx), valpha(nlmx),
     &        beta(nlmx), rbeta(nlmx), vbeta(nlmx),
     &        gamma(nlmx), vn, c, imag, 
     &        en(4,4), coef1, coef2, coef3, coef4,
     &        dca, dea, gca, gea,
     &        up(nb2), wp(nb2), usv(nb2), wsv(nb2),
     &        bm, bn, rvs, vsh(nb2)
c                                                                       
      complex*16 a(4,4,nlmx), b(4,4,nlmx), aj(4,4),
     &           s, da, dc, de, gc, ge, 
     &           al(2,2,nlmx), bl(2,2,nlmx), sl, ab, 
     &           p(nlmx), q(nlmx), cp, sp, cq, sq
c
      parameter ( imag=(0.0,1.0) )                                      
c                                                                       
c     *** complex velocity for dissipative medium ***
c
      do 1 m=1,n                                                        
        alpha(m)=valpha(m)+imag*valpha(m)/(2.0*qa(m))                   
     &          +valpha(m)/(8.0*qa(m)**2)                               
        beta(m)=vbeta(m)+imag*vbeta(m)/(2.0*qb(m))                      
     &         +vbeta(m)/(8.0*qb(m)**2)                                 
    1 continue                                                          
c
      if (lc.eq.1) then                                               
         vn=alpha(n)                                                       
      else
         vn=beta(n)
      end if
c
c     *** apparent velocity ***
c
      c=vn/sin(ang)                                                     
c
      do 2 m=1,n                                                        
c
        cal=real((c/alpha(m))**2-1. )                                   
        if (cal.ge.0.) then
           ralpha(m)=csqrt((c/alpha(m))**2-1. )                            
        else
           ralpha(m)=-imag*csqrt(1. -(c/alpha(m))**2)
        end if                      
c
        cbe=real((c/beta(m))**2-1. )                                    
        if (cbe.ge.0.) then
           rbeta(m)=csqrt((c/beta(m))**2-1. )                              
        else
           rbeta(m)=-imag*csqrt(1. -(c/beta(m))**2)
        end if                        
c
        gamma(m)=2.*(beta(m)/c)**2                                      
c
    2 continue                                                          
c
      if (lc.le.2) then
c                                                                       
c     *** inverse matrix at the lowermost interface for P-SV ***
c
         en(1,1)=-2.*(beta(n)/alpha(n))**2                                 
         en(1,2)=0.                                                        
         en(1,3)=1./(rho(n)*alpha(n)**2)                                   
         en(1,4)=0.                                                        
         en(2,1)=0.                                                        
         en(2,2)=c**2*(gamma(n)-1.)/(alpha(n)**2*ralpha(n))                
         en(2,3)=0.                                                        
         en(2,4)=1./(rho(n)*alpha(n)**2*ralpha(n))                         
         en(3,1)=(gamma(n)-1.)/(gamma(n)*rbeta(n))                         
         en(3,2)=0.                                                        
         en(3,3)=-1./(rho(n)*c**2*gamma(n)*rbeta(n))                       
         en(3,4)=0.                                                        
         en(4,1)=0.                                                        
         en(4,2)=1.                                                        
         en(4,3)=0.                                                        
         en(4,4)=1./(rho(n)*c**2*gamma(n))                                 
         coef1=2.*c**2/alpha(n)**2                                         
         coef2=coef1/ralpha(n)                                             
         coef3=2.0/gamma(n)                                                
         coef4=coef3/rbeta(n)                                              
c
      end if
c
c     *** loop on frequency ***
c
      do 5 kk=1,nb2                                                     
c
        nn=n-1                                                          
        do 3 m=1,nn                                                     
          p(m)=w(kk)*ralpha(m)*h(m)*rs(m)/c                             
          q(m)=w(kk)*rbeta(m)*h(m)*rs(m)/c                              
          cp=cdcos(p(m))                                                
          sp=cdsin(p(m))                                                
          cq=cdcos(q(m))                                                
          sq=cdsin(q(m))                                                
          bm=beta(m)**2*rho(m)*rbeta(m)/rs(m)
c                           
c         **  matrix at layer interfaces  **                             
c
          if (lc.le.2) then
c
c            ** for P-SV problem
c
             a(1,1,m)=gamma(m)*cp-(gamma(m)-1.0)*cq                        
             a(1,2,m)=imag*((gamma(m)-1.0)*sp/ralpha(m)                    
     &            +gamma(m)*rbeta(m)*sq)                                
             a(1,3,m)=-(cp-cq)/(rho(m)*c**2)                               
             a(1,4,m)=imag*(sp/ralpha(m)+rbeta(m)*sq)/(rho(m)*c**2)        
             a(2,1,m)=-imag*(gamma(m)*ralpha(m)*sp                         
     &            +(gamma(m)-1.0)*sq/rbeta(m))                          
             a(2,2,m)=-(gamma(m)-1.0)*cp+gamma(m)*cq                       
             a(2,3,m)=imag*(ralpha(m)*sp+sq/rbeta(m))/(rho(m)*c**2)        
             a(2,4,m)=a(1,3,m)                                             
             a(3,1,m)=rho(m)*c**2*gamma(m)*(gamma(m)-1.0)*(cp-cq)          
             a(3,2,m)=imag*(rho(m)*c**2*((gamma(m)-1.0)**2*sp/ralpha(m)    
     &            +gamma(m)**2*rbeta(m)*sq))                            
             a(3,3,m)=a(2,2,m)                                             
             a(3,4,m)=a(1,2,m)                                             
             a(4,1,m)=imag*(rho(m)*c**2*(gamma(m)**2*ralpha(m)*sp          
     &            +(gamma(m)-1.0)**2*sq/rbeta(m)))                      
             a(4,2,m)=a(3,1,m)                                             
             a(4,3,m)=a(2,1,m)                                             
             a(4,4,m)=a(1,1,m)                                             
          else
c
c            ** for SH problem **
c
             al(1,1,m)=cq                                                  
             al(2,2,m)=al(1,1,m)                                           
             al(1,2,m)=imag*sq/bm                                          
             al(2,1,m)=imag*sq*bm
c
          end if
c                                          
    3   continue                                                        
c
        if (lc.le.2) then
c
c       **  matrix product for P-SV case **
c
           m=n-1                                                           
    4      continue                                                        
           if(m.eq.1)go to 40                                              
           do 20 i=1,4                                                     
           do 20 k=1,4                                                     
             s=0.                                                          
             do 10 j=1,4                                                   
               s=s+a(i,j,m)*a(j,k,m-1)                                     
   10        continue                                                      
             b(i,k,m-1)=s                                                  
   20      continue                                                        
           do 30 i=1,4                                                     
           do 30 k=1,4                                                     
             a(i,k,m-1)=b(i,k,m-1)                                         
   30      continue                                                        
           m=m-1                                                           
           go to 4                                                         
   40      continue                                                        
           do 60 i=1,4                                                     
           do 60 k=1,4                                                     
             s=0.                                                          
             do 50 j=1,4                                                   
               s=s+en(i,j)*a(j,k,1)                                        
   50        continue                                                      
             aj(i,k)=s                                                     
   60      continue                                                        
           da=(aj(1,1)-aj(2,1))*(aj(3,2)-aj(4,2))-(aj(1,2)-aj(2,2))        
     &          *(aj(3,1)-aj(4,1))                                            
        if (lc.eq.1) then
c
c       **  up horizontal/total, wp vertical/total of P  **             
c
           dc=aj(4,2)-aj(3,2)                                              
           de=aj(4,1)-aj(3,1)                                              
           dca=dc/da                                                       
           dea=de/da                                                       
           up(kk)=dca*coef1*alpha(n)/c                                     
           wp(kk)=dea*coef2*alpha(n)*ralpha(n)/c
c                           
        else if (lc.eq.2) then
c
c     **  usv horizontal/total, wsv vertical/total of SV  **          
c
           gc=aj(1,2)-aj(2,2)                                              
           ge=aj(2,1)-aj(1,1)                                              
           gca=gc/da                                                       
           gea=ge/da                                                       
           usv(kk)=gca*coef4*beta(n)*rbeta(n)/c                            
           wsv(kk)=gea*coef3*beta(n)/c                                     
c
        end if
c
      else
c
c       **  matrix product for SH waves  **                             
c
         m=n-1                                                           
  114    continue                                                        
         if(m.eq.1) go to 140                                            
         do 120 i=1,2                                                    
         do 120 k=1,2                                                    
           sl=0.0                                                        
           do 110 j=1,2                                                  
             sl=sl+al(i,j,m)*al(j,k,m-1)                                 
  110      continue                                                      
           bl(i,k,m-1)=sl                                                
  120    continue                                                        
         do 130 i=1,2                                                    
         do 130 k=1,2                                                    
           al(i,k,m-1)=bl(i,k,m-1)                                       
  130    continue                                                        
         m=m-1                                                           
         go to 114                                                       
  140    continue                                                        
         bn=beta(n)**2*rho(n)*rbeta(n)/rs(n)                             
         ab=al(2,1,1)+bn*al(1,1,1)
c                                       
c       **  vsh horizontal/total of SH  **                              
c
         rvs=2.*bn/ab                                                   
         vsh(kk)=rvs
c
      end if
c                                                     
    5 continue                                                          
c 
      return                                                            
      end                                                               

      FUNCTION dpythag(a,b)
      DOUBLE PRECISION a,b,dpythag
      DOUBLE PRECISION absa,absb
      absa=abs(a)
      absb=abs(b)
      if(absa.gt.absb)then
        dpythag=absa*sqrt(1.0d0+(absb/absa)**2)
      else
        if(absb.eq.0.0d0)then
          dpythag=0.0d0
        else
          dpythag=absb*sqrt(1.0d0+(absa/absb)**2)
        endif
      endif
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software '%1&9p#!.

subroutine priorvalue(point,d_min,d_max,beta_min,beta_max,width,pv_min,pv_max)

real point,d_min,d_max,beta_min,beta_max,width,pv_min,pv_max,v

v=(beta_max-beta_min)*(point-d_min)/(d_max-d_min)+beta_min
pv_min=v-width
pv_max=v+width

! if (point<0) then
! pv_min = beta_min-width
! pv_max = beta_max+width
! endif


return
end
